//
// kmBattGraph
//
// (C)2008 L[gcʂ̃T[}
//

//
// m[gPCp̃obecʂA^Cɕ\郆[eBeBłB
//

unit kmBattGraphUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls, DateUtils, ShellAPI, ComCtrls, Contnrs;

const
  ProgNameStr = 'kmBattGraph';
  VerDateStr = '2008-Feb-24(Sun)';

  DivisionYNumber = 10;
  DivisionLoopMax = 19;
  SpanYMinimum = 10;

  defaultMinutePerPixel = 1;
  defaultRightEndIsCurrent = 1;
  defaultRightEndTime = 214060320;
  defaultDeleteTimer = 43200;     // 30

  K = int64(600000000);  // Pʂŗ^ꂽl100nsPʂɂ萔

  defaultColorBGoff = $FFFFFF;
  defaultColorBGac = $C8FFC8;
  defaultColorBGbatt= $C8C8FF;
  defaultColorBGmix = $C8FFFF;
  defaultColorScale1 = clLime;    // ڐ
  defaultColorScale2 = clGreen;   // ڐ(lt)
  defaultColorGraph = clBlack;

  defaultStatusBarPanel0Index = 1;
  defaultStatusBarPanel1Index = 2;
  defaultStatusBarPanel2Index = 3;
  defaultStatusBarPanel3Index = 4;
  defaultStatusBarPanel4Index = 5;
  defaultStatusBarPanel5Index = 6;

  defaultMovingAvgMax = 180;

  defaultMakeEndlessLog = 1;

  BattGraphLogFile = 'LOGBatt.csv';       // kmBattGraphpO
  BattGraphLogTempFile = 'LOGtemp.csv';   // l[pꎞt@C
  BattLogFile = 'LOG.csv';                // GetSystemPowerStatus݊O

//
// Xڐ\f[^
//
type
  TSYSTEMFILEDATE = record
    filedate: int64;
    wYear: Integer;
    wMonth: Integer;
    wDay: Integer;
    wHour: Integer;
    wMinute: Integer;
    wSecond: Integer;
    wMilliseconds: Integer;
    ScaleFlag1: Boolean;    // ڐ\ƂTrue
    ScaleFlag2: Boolean;    // X̒l\ƂTrue
  end;

//
// FILETIME\̂Ԃ232rbg̒l
// 64rbgɕϊ邽߂̋p
//
type
  TUnion64 = record
  case Integer of
  0:(w64: int64);
  1:(l32: Longword;
     h32: Longword);
  end;

//
// csvt@C̒lǂݍ
// dr̎cʂobeEO
type
  TBattLog = record
    elapsedSeconds: int64;
    acLineStatus: Byte;
    leftPercent: Byte;
    percentValid: Boolean;
  end;

//
// Ot쐬邽߂̍\
// ̈ʒu̍őlCŏlȂǂL
//
type
  TGraphData = record
    valid: Boolean;
    ac: Boolean;
    battery: Boolean;
    lowValue: Integer;
    hiValue: Integer;
  end;

//
// IɃx𐶐ƂɎgp
//
type
  TLabelItem = class(TLabel);         // xItem
  TLabelList = class(TComponentList); // xǗNX

type
  TkmBattGraphForm = class(TForm)
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    StatusBar1: TStatusBar;
    Image1: TImage;
    Timer1: TTimer;
    DummyLabel1: TLabel;
    MenuFile: TMenuItem;
    MenuFileExit: TMenuItem;
    MenuOpen: TMenuItem;
    MenuSetup: TMenuItem;
    MenuSetupTime: TMenuItem;
    MenuSetupColor: TMenuItem;
    MenuSetupStayInTaskTray: TMenuItem;
    MenuSetupStayInTaskTrayAndHideAtRun: TMenuItem;
    MenuSetupStayInTaskTrayAndOpenAtRun: TMenuItem;
    MenuSetupStayOnTop: TMenuItem;
    MenuSetupStatusBar: TMenuItem;
    MenuSetupMenuOperation: TMenuItem;
    MenuShowStatusBar: TMenuItem;
    MenuShowYAxis: TMenuItem;
    MenuShowXAxis: TMenuItem;
    MenuAbout: TMenuItem;
    MenuAboutVersion: TMenuItem;
    MenuSeparator: TMenuItem;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormPaint(Sender: TObject);
    procedure MenuFileExitClick(Sender: TObject);
    procedure MenuAboutVersionClick(Sender: TObject);
    procedure MenuSetupTimeClick(Sender: TObject);
    procedure MenuSetupColorClick(Sender: TObject);
    procedure MenuOpenClick(Sender: TObject);
    procedure MenuSetupStayInTaskTrayClick(Sender: TObject);
    procedure MenuSetupStayInTaskTrayAndHideAtRunClick(Sender: TObject);
    procedure MenuSetupStayInTaskTrayAndOpenAtRunClick(Sender: TObject);
    procedure MenuShowStatusBarClick(Sender: TObject);
    procedure MenuShowYAxisClick(Sender: TObject);
    procedure MenuShowXAxisClick(Sender: TObject);
    procedure MenuSetupStatusBarClick(Sender: TObject);
    procedure MenuSetupMenuOperationClick(Sender: TObject);
    procedure MenuSetupStayOnTopClick(Sender: TObject);
    procedure MenuExitTrim;
    procedure MenuFileAddedExitClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BattLogToGraphData();
    procedure CsvToBattLogArrayAndTrim();
    procedure AddBatteryLogToCsv();
    procedure ChangeFinishClose(StayInTaskTrayFlag: Boolean);
    procedure CreateYLabel(T1: Integer; Height:Integer);
    Procedure CreateXLabel(mpp: Integer; Image1Left:Integer;
                           Image1Height: Integer;
                           Image1Width: Integer);
    procedure BuildStatusBarPanel();
    procedure GetSystemPS();
    procedure DrawAll();
    procedure DrawScale();
    procedure DrawBatteryGraph();
    procedure DrawBackColor();
    procedure DrawStatusPanel();
    procedure Image1DblClick(Sender: TObject);
    procedure ShowYAxis();
    procedure HideYAxis();
    procedure CalcImage1Height();
    procedure WriteDebugString(InStr: String);
    function Conv125Step(Param: Integer): Integer;
  private
    { Private 錾 }
    AYLabelList: TLabelList;
    AXLabelList: TLabelList;
    procedure HideTaskTray;
    procedure ShowTaskTray;
    procedure WMQueryEndSession(var msg: TWMQueryEndSession);
                                message WM_QUERYENDSESSION;
  protected
    // bZ[W̏I[oCh
    procedure WndProc(var Message: TMessage); override;
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public 錾 }
    // init@C
    minutePerPixel: Integer;
    rightEndIsCurrent: Boolean;
    rightEndTime : int64;
    deleteTimer: Integer;
    colorBGoff: TColor;
    colorBGac: TColor;
    colorBGbatt: TColor;
    colorBGmix: TColor;
    colorScale1: TColor;
    colorScale2: TColor;
    colorGraph: TColor;
    showStatusBar: Boolean;
    statusBarPanelIndex: Array[0..5] of Integer;
    movingAvgMax: Integer;
    movingAvgMaxNew: Integer;
    makeEndlessLog: Boolean;
    ShowUnknownFactor1: Boolean;
    ShowUnknownFactor2: Boolean;
    CloseByDoubleClick: Boolean;
    OpenByDoubleClickAtTaskTray: Boolean;
    CloseByDoubleClickAtTaskTray: Boolean;
    ShowExitMenuInTaskTray: Boolean;
    //
    CurrentSYSTEMTIME: TSYSTEMTIME;
    CurrentFILETIME: TFILETIME;
  end;

var
  kmBattGraphForm: TkmBattGraphForm;

implementation

uses AboutUnit, km_Common, Setup1Unit, Setup2Unit, DebugUnit, Setup3Unit,
  Setup4Unit;

{$R *.dfm}

var
  GraphArray: Array of TGraphData;
  BattLogArray: Array of TBattLog;
  csvOneLine: String;
  StayTrayIcon: boolean;
  NotifyIcon: TNotifyIconData;
  WM_NotifyTaskTray: Uint;
  hiconSmall: HICON;
  hiconLarge: HICON;
  WMQueryEndSessionFlag: Boolean;
  uTaskBarRecreate: Uint;
  WM_MyMessage: Uint;

  FirstFlag: Boolean;
  PrevSecond: Integer;
  PrevMinute: Integer;

  CurrentDateTimeText: String;
  ACLineStatusText: String;
  BatteryFlagText: String;
  BatteryLifePercentText: String;
  BatteryLifeTime1Text: String;
  BatteryLifeTime2Text: String;

  BatteryLifeTimeAvgArray: Array of Int64;
  BatteryLifeTimeAvgLength: Integer;
  BatteryLifeTimeAvgIndex: Integer;
  BatteryLifeTimeAvgSum: Int64;
  BatteryLifeTimeAvgFull: Boolean;

  FirstRun: Boolean;
  InFormCreate: Boolean;  // ɂ̑ΏǗÖ@()

  TrayIcon0to14: Integer; // 0`140`100%B-1 ͕sȂƂ
  CurrentTrayIcon0to14: Integer;
  hTrayIcon: Array[0..15] of HICON;

  DisableTopMost: Boolean; // ɎOɕ\ꎞIɗ}

////////////////////////////////////////////////////////////////
//
// ʊ֐
//
////////////////////////////////////////////////////////////////

//
// fobOp̕\/O쐬
//
procedure TkmBattGraphForm.WriteDebugString(InStr: String);
var
  hFile: THandle;
  LL: Integer;
  II: Integer;
  lpNumberOfBytesWritten: DWORD;
  DebugLogBuffer: array[0..511] of Char;
  FullPath: String;
begin
  LL := Length(Instr);
  if LL > LogCharMax then LL := 512;
  for II := 0 TO LL - 1 do begin
    DebugLogBuffer[II] := Instr[II + 1]
  end;
  FullPath := ExtractFileDir(Application.ExeName) + '\DebugLog.txt';
  hFile := CreateFile(PChar(FullPath), GENERIC_WRITE,
                      FILE_SHARE_READ + FILE_SHARE_WRITE, NIL,
                      OPEN_ALWAYS,
                      FILE_ATTRIBUTE_NORMAL, 0);
  SetFilePointer(hFile, 0, NIL, FILE_END);
  WriteFile(hFile, DebugLogBuffer, LL, lpNumberOfBytesWritten, nil);
  CloseHandle(hFile)
end;

//
// Xe[^XEo[̕쐬
//
procedure TkmBattGraphForm.DrawStatusPanel();
var
  ii: Integer;
begin
  // g
  for ii := 0 to StatusBar1.Panels.Count - 1 do begin
    case statusBarPanelIndex[ii] of
      0:
        StatusBar1.Panels[ii].Text := '\Ȃ'; // 蓾Ȃ
      1:
        StatusBar1.Panels[ii].Text := CurrentDateTimeText;
      2:
        StatusBar1.Panels[ii].Text := ACLineStatusText;
      3:
        StatusBar1.Panels[ii].Text := BatteryFlagText;
      4: begin
        StatusBar1.Panels[ii].Text := BatteryLifePercentText;
        if StatusBar1.Panels[ii].Text <> 'Unknown' then begin
          StatusBar1.Panels[ii].Text := StatusBar1.Panels[ii].Text + '%'
        end;
      end;
      5: begin
        if ShowUnknownFactor1 then begin
          if BatteryLifeTime1Text = 'Unknown' then begin
            StatusBar1.Panels[ii].Text := BatteryLifeTime1Text + '(';
            if BatteryFlagText = 'No system battery' then begin
              StatusBar1.Panels[ii].Text := StatusBar1.Panels[ii].Text +
                                            'No system battery'
            end else begin
              StatusBar1.Panels[ii].Text := StatusBar1.Panels[ii].Text +
                                            ACLineStatusText
            end;
            StatusBar1.Panels[ii].Text := StatusBar1.Panels[ii].Text + ')'
          end else begin
            StatusBar1.Panels[ii].Text := BatteryLifeTime1Text;
          end
        end else begin
          StatusBar1.Panels[ii].Text := BatteryLifeTime1Text;
        end;
      end;
      6: begin
        if ShowUnknownFactor2 then begin
          if BatteryLifeTime2Text = 'Unknown' then begin
            StatusBar1.Panels[ii].Text := BatteryLifeTime2Text + '(';
            if BatteryFlagText = 'No system battery' then begin
              StatusBar1.Panels[ii].Text := StatusBar1.Panels[ii].Text +
                                            'No system battery'
            end else begin
              StatusBar1.Panels[ii].Text := StatusBar1.Panels[ii].Text +
                                            ACLineStatusText
            end;
            StatusBar1.Panels[ii].Text := StatusBar1.Panels[ii].Text + ')'
          end else begin
            StatusBar1.Panels[ii].Text := BatteryLifeTime2Text;
          end
        end else begin
          StatusBar1.Panels[ii].Text := BatteryLifeTime2Text;
        end
      end
      else
    end;
    // _~[Ex(\)ɕĕ𒲂ׂ()B
    DummyLabel1.Caption := StatusBar1.Panels[ii].Text;
    StatusBar1.Panels[ii].Width := DummyLabel1.Width + 10; // 10͒p
  end
end;

//
// ݒ肳ꂽɊÂCXe[^XEo[\
//
procedure TkmBattGraphForm.BuildStatusBarPanel();
var
  ii: Integer;
begin
  // ܂S
  for ii := 0 to StatusBar1.Panels.Count - 1 do begin
    StatusBar1.Panels.Delete(0)
  end;
  // KvȌ쐬
  if statusBarPanelIndex[0] <> 0 then begin
    StatusBar1.Panels.Add;
    if statusBarPanelIndex[1] <> 0 then begin
      StatusBar1.Panels.Add;
      if statusBarPanelIndex[2] <> 0 then begin
        StatusBar1.Panels.Add;
        if statusBarPanelIndex[3] <> 0 then begin
          StatusBar1.Panels.Add;
          if statusBarPanelIndex[4] <> 0 then begin
            StatusBar1.Panels.Add;
            if statusBarPanelIndex[5] <> 0 then begin
              StatusBar1.Panels.Add
            end
          end
        end
      end
    end
  end
end;

//
// X̃XP[vZ
// ʒuƒlvZ
//
// FT1: FormatType
// 0: 20ƂScaleFlag1TrueC1ԂƂScaleFlag2True
// 1: 1ԂƂScaleFlag1TrueC3ԌƂScaleFlag2True
// 2: 2ԂƂScaleFlag1TrueC0C12ScaleFlag2True
// 3: 6ԂƂScaleFlag1TrueC0ScaleFlag2True
// 4: 12ԂƂScaleFlag1TrueCScaleFlag2True
// 5: 12ԂƂScaleFlag1TrueCScaleFlag2True
// 6: 1ƂScaleFlag1TrueC1C5C10C15C20C25ScaleFlag2True
// 7: 1C5C10C15C20C25ScaleFlag1TrueC1C10C20ScaleFlag2True
// 8: 1C10C20ScaleFlag1TrueC1ScaleFlag2True
// 9: 1ScaleFlag1TrueC1ScaleFlag2True
// 10: 1ScaleFlag1TrueC1C4C7C101ScaleFlag2True
// 11: 1ScaleFlag1TrueC1C71ScaleFlag2True
// 12: 1171ScaleFlag1TrueCxxxxN11ScaleFlag2True
//
procedure CalcXScale(FT1: Integer;
                     var SystemFileDateArray: Array of TSYSTEMFILEDATE);
var
  ii: Integer;
  Size: Integer;
  Time1: Integer;
  Time1Old: Integer;
  Time2: Integer;
  Time2Old: Integer;
begin
  Size := Length(SystemFileDateArray);
  if Size >= 2 then begin
    case FT1 of
      0: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wMinute mod 20;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wHour;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // 0C20C40ւ̃GbW݂ǂf
          Time1 := SystemFileDateArray[ii].wMinute mod 20;
          if Time1Old > Time1 then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // 1ԂƂ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wHour;
          if Time2Old <> Time2 then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      1: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wHour;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wHour mod 3;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // 1Ԃ̕ω݂ǂf
          Time1 := SystemFileDateArray[ii].wHour;
          if Time1Old <> Time1 then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // 3ԂƂɃGbW݂ǂf
          Time2 := SystemFileDateArray[ii].wHour mod 3;
          if Time2Old > Time2 then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      2: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wHour mod 2;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wHour mod 12;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // Ԃւ̕ω݂ǂf
          Time1 := SystemFileDateArray[ii].wHour mod 2;
          if Time1Old > Time1 then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // 0C12
          // ւ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wHour mod 12;
          if Time2Old > Time2 then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      3: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wHour mod 6;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wDay;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // 0, 6Ԃւ̃GbW݂ǂf
          Time1 := SystemFileDateArray[ii].wHour mod 6;
          if Time1Old > Time1 then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // ɂωǂf
          Time2 := SystemFileDateArray[ii].wDay;
          if Time2Old <> Time2 then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      4, 5: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wHour mod 12;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wDay;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // 0, 12̃GbW
          Time1 := SystemFileDateArray[ii].wHour mod 12;
          if Time1Old > Time1 then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wDay;
          if Time2Old <> Time2 then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      6: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wDay;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wDay mod 2;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // ɂ̕ω݂ǂf
          Time1 := SystemFileDateArray[ii].wDay;
          if Time1Old <> Time1 then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // ւ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wDay mod 2;
          if Time2Old > Time2 then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      7: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wDay;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wDay;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // 1C5C10C15C20C25ւ̃GbW݂ǂf
          Time1 := SystemFileDateArray[ii].wDay;
          if (Time1Old <> Time1) and
             ((Time1 = 1) or (Time1 = 5) or (Time1 = 10) or (Time1 = 15)
             or (Time1 = 20) or (Time1 = 25)) then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // 1C10C20ւ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wDay;
          if (Time2Old <> Time2) and
             ((Time2 = 1) or (Time2 = 10) or (Time2 = 20)) then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      8: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wDay;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wDay;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // 1C10C20ւ̃GbW݂ǂf
          Time1 := SystemFileDateArray[ii].wDay;
          if (Time1Old <> Time1) and
             ((Time1 = 1) or (Time1 = 10) or (Time1 = 20)) then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // 1ւ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wDay;
          if (Time2Old <> Time2) and
             (Time2 = 1) then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      9: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wMonth;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wMonth mod 2;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // ̕ω̃GbW݂ǂf
          Time1 := SystemFileDateArray[ii].wMonth;
          if Time1Old <> Time1 then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // ւ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wMonth mod 2;
          if Time2Old > Time2 then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      10: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wMonth mod 2;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wMonth;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // ̕ω̃GbW݂ǂf
          Time1 := SystemFileDateArray[ii].wMonth mod 2;
          if (Time1Old <> Time1) and (Time1 = 1) then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // 1C4C7C10ւ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wMonth;
          if (Time2Old <> Time2) and ((Time2 = 1) or (Time2 = 4) or
             (Time2 = 7) or (Time2 = 10)) then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      11: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wMonth mod 2;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wMonth;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // ̕ω̃GbW݂ǂf
          Time1 := SystemFileDateArray[ii].wMonth mod 2;
          if (Time1Old <> Time1) and (Time1 = 1) then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // 1C7ւ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wMonth;
          if (Time2Old <> Time2) and ((Time2 = 1) or
             (Time2 = 7)) then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False;
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      12: begin
        // ScaleFlag1̏
        Time1Old := SystemFileDateArray[0].wMonth;
        // ScaleFlag2̏
        Time2Old := SystemFileDateArray[0].wYear;
        // c̃[v
        for ii := 1 to Size - 1 do begin
          // ScaleFlag1̏
          // 1C7̕ω̃GbW݂ǂf
          Time1 := SystemFileDateArray[ii].wMonth;
          if (Time1Old <> Time1) and ((Time1 = 1) or
             (Time1 = 7)) then begin
            SystemFileDateArray[ii].ScaleFlag1 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag1 := False
          end;
          // ScaleFlag2̏
          // Nւ̃GbW݂ǂf
          Time2 := SystemFileDateArray[ii].wYear;
          if (Time2Old <> Time2)then begin
            SystemFileDateArray[ii].ScaleFlag2 := True
          end else begin
            SystemFileDateArray[ii].ScaleFlag2 := False
          end;
          // 1O̒lۑ
          Time1Old := Time1;
          Time2Old := Time2
        end
      end;
      else
    end
  end
end;

//
// X
// 1sNZ̕CImage1̍̈ʒuCImage1̍
// Xɕ\镶vZLabelTKmBattGraphFormɓI
// zuB
// mpp: 1sNZ̕
// Image1Left:
//
Procedure TkmBattGraphForm.CreateXLabel(mpp: Integer; Image1Left:Integer;
                                        Image1Height: Integer;
                                        Image1Width: Integer);
var
  Ft1: Integer; // ɏc\邩
  LI: TLabelItem;
  ii: Integer;
  SYSTEMTIME: TSYSTEMTIME;
  FILETIME: TFILETIME;
  u64: TUnion64;
  CurrentDate64: int64;
  SystemFileDateArray: Array of TSYSTEMFILEDATE;
begin
  // łɂTLabel
  if Assigned(AXLabelList) then begin
    FreeAndNil(AXLabelList)
  end;
  // TLabelList𐶐
  AXLabelList := TLabelList.Create(True);
  // /sNZɑΉ
  case mpp of
    1: begin
      Ft1 := 0
    end;
    2..4: begin
      Ft1 := 1
    end;
    5..9: begin
      Ft1 := 2
    end;
    10..19: begin
      Ft1 := 3
    end;
    20..29: begin
      Ft1 := 4
    end;
    30..59: begin
      Ft1 := 5
    end;
    60..119: begin
      Ft1 := 6
    end;
    120..299: begin
      Ft1 := 7
    end;
    300..1439: begin
      Ft1 := 8
    end;
    1440..2879: begin
      Ft1 := 9
    end;
    2890..7299: begin
      Ft1 := 10
    end;
    7300..10079: begin
      Ft1 := 11
    end;
    10080..43199: begin
      Ft1 := 12
    end;
    else
      Ft1 := 0
  end;
  // XڐǗzm
  SetLength(SystemFileDateArray, Image1Width);
  // X쐬邽߂̓tzɏ
  if rightEndIsCurrent then begin
    // ܂̎擾
    u64.h32 := CurrentFILETIME.dwHighDateTime;
    u64.l32 := CurrentFILETIME.dwLowDateTime;
    CurrentDate64 := u64.w64
  end else begin
    // ݒ肳ꂽ擾
    CurrentDate64 := rightEndTime * K
  end;
  for ii := 0 to Length(SystemFileDateArray) - 1 do begin
    SystemFileDateArray[ii].filedate := CurrentDate64 -
                                        (mpp * K * (Image1Width - ii));
    u64.w64 := SystemFileDateArray[ii].filedate;
    FILETIME.dwLowDateTime := u64.l32;
    FILETIME.dwHighDateTime := u64.h32;
    FileTimeToSystemTime(FILETIME, SYSTEMTIME);
    SystemFileDateArray[ii].wYear := SYSTEMTIME.wYear;
    SystemFileDateArray[ii].wMonth := SYSTEMTIME.wMonth;
    SystemFileDateArray[ii].wDay := SYSTEMTIME.wDay;
    SystemFileDateArray[ii].wHour := SYSTEMTIME.wHour;
    SystemFileDateArray[ii].wMinute := SYSTEMTIME.wMinute;
    SystemFileDateArray[ii].wSecond := SYSTEMTIME.wSecond;
    SystemFileDateArray[ii].wMilliseconds := 0
  end;
  CalcXScale(Ft1, SystemFileDateArray);
  // Xx𐶐
  for ii := 0 to Length(SystemFileDateArray) - 1 do begin
    // XP[̂
    Image1.Canvas.Pen.Color := colorScale1;
    if SystemFileDateArray[ii].ScaleFlag1 then begin
      Image1.Canvas.MoveTo(ii, 0);
      Image1.Canvas.LineTo(ii, Image1Height);
      Image1.Canvas.Pixels[ii, Image1Height] := Image1.Canvas.Pen.Color
    end;
    // XP[Ɩڐ
    Image1.Canvas.Pen.Color := colorScale2;
    if SystemFileDateArray[ii].ScaleFlag2 then begin
      Image1.Canvas.MoveTo(ii, 0);
      Image1.Canvas.LineTo(ii, Image1Height);
      Image1.Canvas.Pixels[ii, Image1Height] := Image1.Canvas.Pen.Color;
      // ڐ
      LI := TLabelItem.Create(nil);
      LI.Parent := Self;
      LI.Alignment := taLeftJustify; // E
      LI.Left := Image1Left + ii;
      LI.Height := 11;
      LI.Top := Image1Height + 2;
      LI.Color := clBtnFace;
      // LvV͖ʓ|cB
      case Ft1 of
        0: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wHour) + ''
        end;
        1: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wDay) + '' +
                        IntToStr(SystemFileDateArray[ii].wHour) + ''
        end;
        2: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wDay) + '' +
                        IntToStr(SystemFileDateArray[ii].wHour) + ''
        end;
        3: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wDay) + ''
        end;
        4: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wDay) + ''
        end;
        5: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wDay) + ''
        end;
        6: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wDay) + ''
        end;
        7: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wDay) + ''
        end;
        8: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wMonth) + ''
        end;
        9: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wMonth) + ''
        end;
        10: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wMonth) + ''
        end;
        11: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wMonth) + ''
        end;
        12: begin
          LI.Caption := IntToStr(SystemFileDateArray[ii].wYear) + 'N'
        end
      else
      end;
      // LvVtH[̊Oɂ͂ݏoȂ悤ɂ
      // Width͕_ŎIɌ܂
      if LI.Left + LI.Width > (Image1Width + Image1.Left) then begin
        LI.Left := Image1Width + Image1.Left - LI.Width
      end;
      LI.Font.Size := 8;
      AXLabelList.Add(LI)
    end
  end
end;

//
// t@Cj[̋@\ɂāCIƕƂ؂ւ
//
procedure TkmBattGraphForm.ChangeFinishClose(StayInTaskTrayFlag: Boolean);
begin
  if StayInTaskTrayFlag = True then begin
    // ɂ
    MenuFileExit.Caption := '(&C)';
    ShowTaskTray
  end else begin
    // Iɂ
    MenuFileExit.Caption := 'I(&X)';
    HideTaskTray
  end
end;

//
// ^XNEgC̕\
//
// Shell_NotifyIcongp
// ^XNEgC̃ACR
// łɃ^XNEgCɃACRȂƂɂsĂ
// Ȃ悤
//
procedure TkmBattGraphForm.HideTaskTray;
begin
//  WriteDebugString('HideTaskTray' + #$D + #$A);
  StayTrayIcon := False;
  with NotifyIcon do begin
    cbSize := SizeOf(TNotifyIconData);
    Wnd := Handle;
    uID := 0;
    uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
    uCallbackMessage := WM_NotifyTaskTray;
    hIcon := hiconSmall;   // ȃACRݒ
    szTip := '' // ӖȂ
  end;
  Shell_NotifyIcon(NIM_DELETE, @NotifyIcon);
  // 풓łIj[\邩ǂ
  MenuExitTrim
end;

//
// ^XNEgC̕\Jn
//
// Shell_NotifyIcongp
// ^XNEgCɃACR\
// łɃ^XNEgCɃACR݂ƂɎsĂv̂悤
//
procedure TkmBattGraphForm.ShowTaskTray;
var
  strSzTip: String;
  retBOOL: Boolean;
  ii: Integer;
begin
  // szTip̐ݒ
  if OpenByDoubleClickAtTaskTray then begin
    // FormCreate̒ł̓tH[\ݒɂȂĂĂ
    // VisibleFalseȂ̂œʂɔ肷
    if InFormCreate then begin
      if Boolean(MenuSetupStayInTaskTrayAndOpenAtRun.Checked) then begin
        if CloseByDoubleClickAtTaskTray then begin
          strSzTip := '_uENbNŕ'
        end else begin
          strSzTip := ''
        end
      end else begin
        strSzTip := '_uENbNŊJ'
      end
    end else begin
      if kmBattGraphForm.Visible then begin
        if CloseByDoubleClickAtTaskTray then begin
          strSzTip := '_uENbNŕ'
        end else begin
          strSzTip := ''
        end
      end else begin
        strSzTip := '_uENbNŊJ'
      end
    end
  end else begin
    strSzTip := 'NbNŃj['
  end;
  //
  StayTrayIcon := True;
  //
  with NotifyIcon do begin
    cbSize := SizeOf(TNotifyIconData);
    Wnd := Handle;
    uID := 0;
    uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
    uCallbackMessage := WM_NotifyTaskTray;
    if TrayIcon0to14 = -1 then begin
      hIcon := hTrayIcon[15]
    end else begin
      hIcon := hTrayIcon[TrayIcon0to14]
    end;
    for ii := 0 to Length(strSzTip) - 1 do begin
      szTip[ii] := strSzTip[ii + 1]
    end;
    szTip[Length(strSzTip)] := Char(0);
  end;
  // ܂NIM_MODIFYs
  retBool := Shell_NotifyIcon(NIM_MODIFY, @NotifyIcon);
  if retBool then begin
  end else begin
     // G[NIM_ADDs
     // Ɨ\ǊȒP
     // mIɂ͂łɕ\Ă\͂邩ɍ
     Shell_NotifyIcon(NIM_ADD, @NotifyIcon);
  end;
  CurrentTrayIcon0to14 := TrayIcon0to14;
  // 풓łIj[\邩ǂ
  MenuExitTrim
end;

//
// FILETIME^SYSTEMTIME^
//
procedure FileTimeToYYYYmmddhhmmssms(Int64FILETIME: Int64;
                            var Year: Integer;
                            var Month: Integer;
                            var Day: Integer;
                            var Hour: Integer;
                            var Minute: Integer;
                            var Second: Integer;
                            var Milliseconds: Integer);
var
  SYSTEMTIME: TSYSTEMTIME;
  FILETIME: TFILETIME;
  u64: TUnion64;
begin
  u64.w64 := Int64FILETIME;
  FILETIME.dwLowDateTime := u64.l32;
  FILETIME.dwHighDateTime := u64.h32;
  FileTimeToSystemTime(FILETIME, SYSTEMTIME);
  Year := SYSTEMTIME.wYear;
  Month := SYSTEMTIME.wMonth;
  Day := SYSTEMTIME.wDay;
  Hour := SYSTEMTIME.wHour;
  Minute := SYSTEMTIME.wMinute;
  Second := SYSTEMTIME.wSecond;
  Milliseconds := SYSTEMTIME.wMilliseconds
end;

//
// fobOp FILETIME𕶎ɕϊ
//
function FileTimeToStr(int64FILETIME: int64): String;
var
  Year: Integer;
  Month: Integer;
  Day: Integer;
  Hour: Integer;
  Minute: Integer;
  Second: Integer;
  Milliseconds: Integer;
begin
  FileTimeToYYYYmmddhhmmssms(Int64FILETIME, Year, Month, Day, Hour, Minute,
                             Second, Milliseconds);
  Result := Format('%4.4dN%2.2d%2.2d%2.2d%2.2d%2.2db',
                   [Year, Month, Day, Hour, Minute, Second]);
end;

//
// TBattLog^̃f[^TvOĕ\ɕKvȏ擾
//
// w肳ꂽtimeRangeLCtimeRangeHTBattLogz𒲂ׂB
// ̎w肳ꂽ͈
// timeRangeL =< t < timeRangeH
// ̃WȂɑ݂f[^
// CőlCŏl𓾂
// p\RAC쓮obe쓮B
// ݂ĂΗTrueɂ
// obecʂUnknownȂvalidtOFalseɂ
// validCount͊܂܂ĂLȃf[^̌Ot쐬̈Ӗ͂Ȃ
//

procedure SamplingSpecifiedRange(var LogArray: array of TBattLog;
                                 start: integer; timeRangeL: int64;
                                 timeRangeH: int64; var validCount: integer;
                                 var valueMin: integer;
                                 var valueMax: integer;
                                 var next: integer;
                                 var ac: Boolean;
                                 var battery: boolean;
                                 var valid: boolean);
var
  ii: Integer;
  foundState: Integer;   // 0: ĂȂ 1: 
begin
  foundState := 0;
  validCount := 0;  // ŏvalidƂmin/maxɓl
                    // Ɏgp
  valid := False;
  valueMin := 0;
  valueMax := 0;
  ac := false;
  battery := false;
  next := 0;
  ii := start;
  if (ii <= Length(LogArray) - 1) then begin
    while(ii <= Length(LogArray) - 1) do begin
      case foundState of
        0: begin
          if timeRangeL <= LogArray[ii].elapsedSeconds then begin
            // timeRangeL蓙傫elapsedSeconds܂ޗvf
            // ݂
            if timeRangeH <= LogArray[ii].elapsedSeconds then begin
              // timeRangeH傫I
              break
            end else begin
              // timeRangeH菬
              if validCount = 0 then begin
                // count0validȂminmaxleftPercent
                // ЂƂłLȂvalidTrue
                if LogArray[ii].percentValid then begin
                  valueMin := LogArray[ii].leftPercent;
                  valueMax := LogArray[ii].leftPercent;
                  valid := True;
                  validCount := validCount + 1
                end;
                case LogArray[ii].acLineStatus of
                  0: battery := True;
                  1: ac := True
                end
              end else begin
                // count0傫percentValid
                // LȂ
                // ꂼ̒lXV
                // ЂƂłLȂvalidTrue
                if LogArray[ii].percentValid then begin
                  if valueMin > LogArray[ii].leftPercent then begin
                    valueMin := LogArray[ii].leftPercent
                  end;
                  if valueMax < LogArray[ii].leftPercent then begin
                    valueMax := LogArray[ii].leftPercent
                  end;
                  valid := True;
                  validCount := validCount + 1
                end;
                case LogArray[ii].acLineStatus of
                  0: battery := True;
                  1: ac := True
                end
              end;
            end;
            foundState := 1
          end
        end;
        1: begin
          if timeRangeH <= LogArray[ii].elapsedSeconds then begin
            // timeRangeH傫I
            foundState := 2
          end else begin
            // timeRangeH菬
            if validCount = 0 then begin
              // count0傫percentValid
              // LȂ炻ꂼ̒lXV
              // ЂƂłLȂvalidTrue
              if LogArray[ii].percentValid then begin
                valueMin := LogArray[ii].leftPercent;
                valueMax := LogArray[ii].leftPercent;
                valid := True;
                validCount := validCount + 1
              end;
              case LogArray[ii].acLineStatus of
                0: battery := True;
                1: ac := True
              end
            end else begin
              // count0傫percentValid
              // LȂ召r
              // ꂼ̒lXV
              // ЂƂłLȂvalidTrue
              if LogArray[ii].percentValid then begin
                if valueMin > LogArray[ii].leftPercent then begin
                  valueMin := LogArray[ii].leftPercent
                end;
                if valueMax < LogArray[ii].leftPercent then begin
                  valueMax := LogArray[ii].leftPercent
                end;
                valid := True;
                validCount := validCount + 1
              end;
              case LogArray[ii].acLineStatus of
                0: battery := True;
                1: ac := True
              end
            end;
          end
        end;
        else begin
          break
        end
      end;
      next := ii;
      ii := ii + 1
    end
  end
end;

//
// yyyy-mm-dd`̕Nɕ
// hh:mm:ss`̕bɕ
//
procedure SeparateString(Param1: String; Separater: String; var First: Word;
                          var Second: Word; var Third: Word);
var
  hyphenpos: Integer;
  temp2: String;
  temp3: String;
begin
  hyphenpos := Pos(Separater, Param1);
  First := StrToInt(Copy(Param1, 1, hyphenpos - 1));
  temp2 := Copy(Param1, hyphenpos + 1, Length(Param1) - hyphenpos);
  hyphenpos := Pos(Separater, temp2);
  Second := StrToInt(Copy(temp2, 1, hyphenpos - 1));
  temp3 := Copy(temp2, hyphenpos + 1, Length(temp2) - hyphenpos);
  Third := StrToInt(temp3)
end;

//
// 󔒂菜
// DelphiCommaText󔒂f~^ƌȂĂ܂̂łނ𓾂󔒂
// 菜
//
function DeleteSpace(InParam: String): String;
var
  ii: Integer;
begin
  Result := '';
  for ii := 1 to Length(InParam) do begin
    if InParam[ii] <> ' ' then begin
      Result := Result + InParam[ii]
    end
  end
end;

//
// ^ꂽ1-2-5Xebv̐ɕϊ
// 0,1,2,3,4,5... 1,2,5,10,20,50,100,200,500ɕϊ
// 1-2-5Xebv̖ڐ쐬̂Ɏgp
//
function TkmBattGraphForm.Conv125Step(Param: Integer): Integer;
var
  cv1: Integer; // ϐ1  0C1C2C3C4...ƕω
  cv2: Integer; // ϐ2  0C1C2C0C1C2...ƕω
  cv3: Integer; // ϐ3  1C2C5C1C2C5...ƕω
  cv4: Integer; // ϐ4  0C0C0C1C1C1...ƕω
  cv5: Integer; // ϐ5  1C1C1C10C10C10...ƕω
  cv6: Integer; // ϐ6  1C2C5C10C20C50...ƕω
  ii: Integer;
begin
  cv1 := Param;
  cv2 := cv1 mod 3;
  case cv2 of
    0: cv3 := 1;
    1: cv3 := 2;
    2: cv3 := 5;
  else
    cv3 := 1
  end;
  cv4 := cv1 div 3;
  cv5 := 1;
  for ii := 1 to cv4 do begin
    cv5 := cv5 * 10
  end;
  cv6 := cv5 * cv3;
  Conv125Step := cv6
end;

//
// bbɕϊ
//
function SecondsToHHMMSS(Seconds: DWORD): String;
var
  HH: Integer;
  MM: Integer;
  SS: Integer;
begin
  if Seconds = $FFFFFFFF then begin
    Result := 'Unknown'
  end else begin
    HH := Seconds div 3600;
    MM := (Seconds mod 3600) div 60;
    SS := Seconds mod 60;
    Result := Format('%2.2d:%2.2d:%2.2d', [HH, MM, SS])
  end
end;

/////////////////////////////////////////////////////////////////
//
// bZ[W̃Cxg
//
/////////////////////////////////////////////////////////////////

//
// QueryEndSession̏tbN
// WindowsIƂɂ̃bZ[WB
// 풓ĂĂI
//
procedure TkmBattGraphForm.WMQueryEndSession(var msg: TWMQueryEndSession);
begin
  WMQueryEndSessionFlag := True;
  inherited
end;

//
// bZ[W̏tbN
//
procedure TkmBattGraphForm.WndProc(var Message: TMessage);
var
  lpPoint: TPoint;
begin
  if Message.Msg = WM_NotifyTaskTray then begin
    // NortifyTaskTraybZ[W̏
    case Message.LParam of
      // NbN̏
      WM_LBUTTONDOWN: begin
        if not OpenByDoubleClickAtTaskTray then begin
          // |bvAbvj[\
          GetCursorPos(lpPoint);
          SetForegroundWindow(Handle);
          PopupMenu2.Popup(lpPoint.x, lpPoint.y)
        end
      end;
      // ENbN̏
      WM_RBUTTONDOWN: begin
        // ȂɂȂ
      end;
      // {^̃_uENbN̏
      WM_LBUTTONDBLCLK: begin
        // tH[\ĂƂɃ_uENbNŃtH[B
        if CloseByDoubleClickAtTaskTray and kmBattGraphForm.Visible then begin
          kmBattGraphForm.Hide;
          ShowTaskTray;
//        end else if OpenByDoubleClickAtTaskTray and 
//                    not kmBattGraphForm.Visible then begin
        end else if OpenByDoubleClickAtTaskTray then begin
          kmBattGraphForm.Show;
          Application.Restore;
          // ɉBĂOʂɂ
          SetForegroundWindow(Handle);
          ShowTaskTray;
        end;
      end;
    end
  // explorer.exeċÑbZ[WŃ^XNEgCEACRĕ\
  end else if (Message.Msg = uTaskBarRecreate) then begin
    ShowTaskTray
  // dNꍇCdɋNvO烁bZ[W
  // Ă̂ŁCʏ̕\ɖ߂
  end else if (Message.Msg = WM_MyMessage) then begin
    kmBattGraphForm.Show;
    Application.Restore;
  // ȊO͌̏
  end else begin
    inherited
  end
end;

////////////////////////////////////////////////////////////////
//
// f[^ǂݍŃOt쐬
//
////////////////////////////////////////////////////////////////

//
// csv1s̃f[^TBattLog^ɕϊ
//
procedure CsvToBattLogType(InParam1: String; var OutParam1: TBattLog);
var
  SL1: TStringList;
  yyyymmdd: String;
  hhmmss: String;
  u64: TUnion64;
  FILETIME: TFILETIME;
  SYSTEMTIME: TSYSTEMTIME;
begin
  SL1 := TStringList.Create;
  try
    SL1.CommaText := DeleteSpace(InParam1);
    // yyyy, mm, ddɕ
    yyyymmdd := SL1[0];
    separateString(yyyymmdd, '-', SYSTEMTIME.wYear, SYSTEMTIME.wMonth,
                   SYSTEMTIME.wDay);
    // hh, mm, ssɕ
    hhmmss := SL1[1];
    separateString(hhmmss, ':', SYSTEMTIME.wHour, SYSTEMTIME.wMinute,
                   SYSTEMTIME.wSecond);
    SYSTEMTIME.wMilliseconds := 0;
    SystemTimeToFileTime(SYSTEMTIME, FILETIME);
    u64.h32 := FILETIME.dwHighDateTime;
    u64.l32 := FILETIME.dwLowDateTime;
    OutParam1.elapsedSeconds := u64.w64;
    // dr쓮AC쓮
    if SL1[2] = 'AC' then begin
      OutParam1.acLineStatus := 1
    end else if SL1[2] = 'Battery' then begin
      OutParam1.acLineStatus := 0
    end else begin
      OutParam1.acLineStatus := 255
    end;
    // obec
    if SL1[4] = 'Unknown' then begin
      // obeȂUnknownƂ񂪓Ă̂ł0ƌȂ
      OutParam1.leftPercent := 0
    end else begin
      OutParam1.leftPercent := StrToInt(SL1[4])
    end;
    // obecʂ̐lL𔻒肷
    if SL1[4] <> 'Unknown' then begin
      OutParam1.percentValid := True
    end else begin
      OutParam1.percentValid := False
    end;
  finally
    SL1.Free
  end
end;

//
// csvt@CTBattLog^̔zɓǂݍ
// csvt@Cyyyy-mm-dd, hh:mm:ssFILETIME^ɕϊĊi[
// ̑KvȕϊsTBattLog^Ɋi[
// csvt@ČÂR[h폜
//
procedure TkmBattGraphForm.CsvToBattLogArrayAndTrim();
var
  SL1: TStringList;
  LineCount: Integer;
  II: Integer;
  jj: Integer;
  SL2: TStringList;
  u64: TUnion64;
  deleteTime64: int64;
  deletePointer: Integer;
  Len: Integer;
  FolderDir: String;
begin
  FolderDir := ExtractFileDir(Application.ExeName);
  SL1 := TStringList.Create;
  SL2 := TStringList.Create;
  try
    // StringListɓǂݍ
    try
      SL1.LoadFromFile(FolderDir + '\' + BattGraphLogFile);
    except
    end;
    LineCount := SL1.Count;
    // ϒzm
    if LineCount >= 1 then begin
      // BattGraphLogFileǂݍ
      SetLength(BattLogArray, LineCount - 1);
      // StringList̓eϒzɑ
      // FILETIMEɕϊ
      for II := 1 to LineCount - 1 do begin
        CsvToBattLogType(SL1[II], BattLogArray[II - 1]);
        Application.ProcessMessages
      end;
      // ÂR[h폜
      // ̓
      u64.h32 := CurrentFILETIME.dwHighDateTime;
      u64.l32 := CurrentFILETIME.dwLowDateTime;
      // 폜t
      deleteTime64 := u64.w64 - deleteTimer * K;    // 폜
      deletePointer := 0;
      // 폜̈ʒu
      Len := Length(BattLogArray);
      for ii := 0 to Len - 1 do begin
        if deleteTime64 <= BattLogArray[ii].elapsedSeconds then begin
          deletePointer := ii;
          break
        end
      end;
      // 擪1s(wb_s)Rs[
      SL2.ADD(SL1[0]);
      // cRs[
      for jj := deletePointer + 1 to SL1.Count - 1 do begin
        SL2.Add(SL1[jj]);
        Application.ProcessMessages
      end;
      // o
      SL2.SaveToFile(BattGraphLogTempFile);
      // Ât@C폜
      DeleteFile(FolderDir + '\' + BattGraphLogFile);
      // l[
      RenameFile(BattGraphLogTempFile, FolderDir + '\' + BattGraphLogFile)
    end else begin
      SetLength(BattLogArray, 0)
    end;
  finally
    SL1.Free;
    SL2.Free
  end
end;

//
// TBattLog^̔z񂩂TImagȇ傫ɑΉ\ɕKvȃf[^
// TGraphData^̔zgݗĂ
//
procedure TkmBattGraphForm.BattLogToGraphData();
var
  pixelTime: int64;   // IntegerƉZɕ]
  u64: TUnion64;
  tempRightEndTime: int64;
  dp: Integer;
  ii: Integer;
  ii64: int64;
  timeL: int64;
  timeH: int64;
  count: Integer;
  min: integer;
  max: integer;
  next: integer;
  ac: Boolean;
  battery: Boolean;
  valid: Boolean;
begin
  // ݒl
  pixelTime := minutePerPixel;     // 1sNZ̎
  if rightEndIsCurrent then begin
    // ܂̎擾
    u64.h32 := CurrentFILETIME.dwHighDateTime;
    u64.l32 := CurrentFILETIME.dwLowDateTime;
    tempRightEndTime := u64.w64
  end else begin
    // ݒ肳ꂽ擾
    tempRightEndTime := rightEndTime * K
  end;
  // \sNZƓ傫̔zmۂ
  SetLength(GraphArray, Image1.Width);
  dp := 0;
  // fobOpɒl\
//  if DebugForm <> nil then
//    DebugForm.Memo1.Clear;
//  if DebugForm <> nil then
//    for ii := 0 to Length(BattLogArray) - 1 do begin
//      DebugForm.Memo1.Lines.Add(Format('%3.3d ', [ii]) +
//      FileTimeToStr(BattLogArray[ii].elapsedSeconds) + ' ' +
//      IntToStr(BattLogArray[ii].elapsedSeconds) + ' ' +
//      IntToStr(BattLogArray[ii].acLineStatus));
//    end;
  for ii := 0 to Image1.Width - 1 do begin
    ii64 := ii;
    timeL := tempRightEndTime - pixelTime * (Image1.Width - ii64) * K;
    timeH := timeL + pixelTime * K;
    SamplingSpecifiedRange(BattLogArray, dp,
                           timeL, timeH,
                           count, min, max, next, ac, battery, valid);
    // validhiValue/lowValueLł邱ƂB
    // validFalsełacbattery͗L
    // count͗Lȃf[^̌B܂Ot쐬ł̈Ӗ͂Ȃ
    // ߋ̂Ȃ
    GraphArray[ii].valid := valid;
    if valid then begin
      GraphArray[ii].lowValue := min;
      GraphArray[ii].hiValue := max
    end else begin
      GraphArray[ii].lowValue := 0;
      GraphArray[ii].hiValue := 0
    end;
    GraphArray[ii].ac := ac;
    GraphArray[ii].battery := battery;
  // fobOpɒl\
//    if DebugForm <> nil then
//      DebugForm.Memo1.Lines.Add(Format('%3.3d', [ii]) + 
//        ' T:' + FileTimeToStr(timeL) +
//        ' TL:' + FileTimeToStr(timeL) + ' ' + IntToStr(timeL) +
//        ' TH:' + FileTimeToStr(timeH) + ' ' + IntToStr(timeH) +
//        ' L:' + IntToStr(GraphArray[ii].lowValue) +
//        ' H:' + IntToStr(GraphArray[ii].hiValue) +
//        ' vd:' + BoolToStr(GraphArray[ii].valid, True));
    dp := next  // x(ɂ)
  end
end;

//
// obecʃOt쐬(Ot̎)
//
procedure TkmBattGraphForm.DrawBatteryGraph();
var
  II: integer;
  posL: Integer;
  posH: Integer;
  prevPosL: Integer;
  prevPosH: Integer;
begin
  // `
  Image1.Canvas.Pen.Color := colorGraph;
  for ii := 0 to Image1.Width - 1 do begin
    if GraphArray[ii].valid then begin
      // 100%ʂ̏ŒlWƂɒ
      PosH := (100 - GraphArray[ii].lowValue) * (Image1.Height - 1) div 100;
      PosL := (100 - GraphArray[ii].hiValue) * (Image1.Height - 1) div 100;
      // fobOpɒl\
//      if DebugForm <> nil then
//        DebugForm.Memo1.Lines.Add(Format('X:%3.3d', [ii]) + 
//        ' L:' + IntToStr(PosL) +
//        ' H:' + IntToStr(PosH));
      // Ȍ񂪂Ώc`悷邩ǂf
      if ii <> 0 then begin
        if GraphArray[ii - 1].valid then begin
          PrevPosH := (100 - GraphArray[ii - 1].lowValue) * (Image1.Height - 1)
                      div 100;
          PrevPosL := (100 - GraphArray[ii - 1].hiValue) * (Image1.Height - 1)
                      div 100;
          // Õf[^Ɛڑ邽߂̏c`悷
          if PosL > PrevPosH then begin
            Image1.Canvas.MoveTo(ii, prevPosH);
            Image1.Canvas.LineTo(ii, PosL);
            Image1.Canvas.Pixels[ii, PosL] := colorGraph
          end else if PosH < PrevPosL then begin
            Image1.Canvas.MoveTo(ii, prevPosL);
            Image1.Canvas.LineTo(ii, PosH);
            Image1.Canvas.Pixels[ii, PosH] := colorGraph
          end
        end
      end;
      // ݂̃f[^`悷
      Image1.Canvas.MoveTo(ii, PosL);
      // sNZLineTosƕ`悳ȂB
      // 1sNZ`悵ĂƎv񂾂ǁB
      // LineTo߂͎n_I_Ă̊Ԃ
      // sNZ`悷񂾁BmȂBorz...
      Image1.Canvas.LineTo(ii, PosH);
      Image1.Canvas.Pixels[ii, PosH] := colorGraph
    end
  end
end;

//
// wiF̐ݒ
// dĂȂƂ̃obN̐FC
// [d̐FC
// d̐FC
// [d/d݂̐F(ʏ1Ĉ݂ɂȂ̂łقƂǂ݂Ȃ)
// ݒ肷
//
procedure TkmBattGraphForm.DrawBackColor();
var
  ii: Integer;
begin
  for ii := 0 to Image1.Width - 1 do begin
    if GraphArray[ii].ac and GraphArray[ii].battery then begin
      Image1.Canvas.Pen.Color := colorBGmix; // F
      Image1.Canvas.MoveTo(ii, 0);
      Image1.Canvas.LineTo(ii, Image1.Height)
    end else if GraphArray[ii].ac then begin
      Image1.Canvas.Pen.Color := colorBGac; // ΂
      Image1.Canvas.MoveTo(ii, 0);
      Image1.Canvas.LineTo(ii, Image1.Height)
    end else if GraphArray[ii].battery then begin
      Image1.Canvas.Pen.Color := colorBGbatt; // IW
      Image1.Canvas.MoveTo(ii, 0);
      Image1.Canvas.LineTo(ii, Image1.Height)
    end else begin
      Image1.Canvas.Pen.Color := colorBGoff; // DF
      Image1.Canvas.MoveTo(ii, 0);
      Image1.Canvas.LineTo(ii, Image1.Height)
    end
  end
end;

//
// YXP[̕ڐ\ʒu쐬
//
// YS:   0-9: 1
//     10-19: 2
//     20-49: 3
//     50-  : 4
//
function YScaleToT1(YS: Integer): Integer;
begin
  if YS < 10 then begin
    Result := 1
  end else if YS < 20 then begin
    Result := 2
  end else if YS < 50 then begin
    Result := 3
  end else begin
    Result := 4
  end
end;

//
// Y0-100%̐l\
// TLabel͓Iɐ
// T1: 1:  0, 100 (Step100)
//     2:  0, 50, 100 (Step50)
//     3:  0, 20, 40, 60, 80, 100 (Step20)
//     4:  0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100 (Step10)
//
procedure TkmBattGraphForm.CreateYLabel(T1: Integer; Height:Integer);
var
  LI: TLabelItem;
  ii: Integer;
  Max: Integer;
  Span: Integer;
begin
  // łɂTLabel
  if Assigned(AYLabelList) then begin
    FreeAndNil(AYLabelList)
  end;
  // TLabel𐶐
  AYLabelList := TLabelList.Create(True);
  // \镶vZ
  case T1 of
    1: begin
      Max := 1;
      Span := 100
    end;
    2: begin
      Max := 2;
      Span := 50
    end;
    3: begin
      Max := 5;
      Span := 20
    end;
    4: begin
      Max := 10;
      Span := 10
    end
    else begin
      Max := 10;
      Span := 10
    end
  end;
  // x\(Y0`100%)
  for ii := 0 to Max do begin
    LI := TLabelItem.Create(nil);
    LI.Parent := Self;
    LI.Alignment := taRightJustify; // E
    LI.Left := Image1.Left - LeftSpace;
    LI.Width := LeftSpace;
    LI.Height := 11;
    LI.Top := (ii * Height) div Max - LI.Height div 2;
    if LI.Top < 0 then LI.Top := 0; // tH[ɂ͂ݏoȂ悤
    // tH[牺ɂ͂ݏoȂ悤
    if LI.Height + LI.Top > Image1.Height then
      LI.Top := Image1.Height - LI.Height + 2; // 2͈ʒu
    LI.Color := clBtnFace;
    LI.Caption := IntToStr(100 - ii * Span);
    LI.Font.Size := 8;
    AYLabelList.Add(LI)
  end
end;

//
// ڐ
//
procedure TkmBattGraphForm.DrawScale();
var
  ii: Integer;
  jj: Integer;
  TempDivision1: Integer;
  Division: Integer;
  YS: Integer;
begin
  //
  // XڐCc()
  //
  CreateXLabel(minutePerPixel, Image1.Left, Image1.Height, Image1.Width);
  //
  // YڐC(c)
  //
  // 
  TempDivision1 := Image1.Height div SpanYMinimum;
  // ̕蓙1-2-5Xebv̕߂
  jj := 0;
  for ii := 0 to DivisionLoopMax do begin
    // z܂ŌJԂ
    if TempDivision1 <= Conv125Step(ii) then begin
      // zЂƂ߂
      jj := ii - 1;
      break
    end
  end;
  // Divisionɂ͕B
  //  1:  Ȃ 0100%
  //  2:  2 0C50C100%
  //  5:  5 0C20C40C60C80C100%
  // 10: 10 0C10C20C30C40... 100%
  // 20: 20 0C5C10C15C20C25... 100%
  // 50: 50 0C2C4C6C8C10C12... 100%
  Division := Conv125Step(jj);
  // 炢l\邩vZ
  //   0-9: 1
  // 10-19: 2
  // 20-49: 3
  // 50-  : 4
  YS := YScaleToT1(Division);
  // Ή̐ڐ̐l\
  // 1:  0, 100 (Step100)
  // 2:  0, 50, 100 (Step50)
  // 3:  0, 20, 40, 60, 80, 100 (Step20)
  // 4:  0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100 (Step10)
  CreateYLabel(YS, Image1.Height);
  //  
  // Division͕(1C2C5C10C20C50)
  for ii := 0 to Division do begin
    jj :=  ii * (Image1.Height - 1) div Division;
    Image1.Canvas.Pen.Color := colorScale1;
    // lĂꏊ̉̐Fς(0100%)
    if (ii = 0) or (ii = Division) then begin
      Image1.Canvas.Pen.Color := colorScale2
    end;
    // lĂꏊ̉̐Fς(ꂼ)
    case Division of
      10: begin
        // 5
        if (ii mod 5) = 0 then 
          Image1.Canvas.Pen.Color := colorScale2
      end;
      20: begin
        // 4C8C12C16
        if (ii mod 4) = 0 then 
          Image1.Canvas.Pen.Color := colorScale2
      end;
      50: begin
        // 5C10C15C20C25C30C35C40C45
        if (ii mod 5) = 0 then 
          Image1.Canvas.Pen.Color := colorScale2
      end;
      else
    end;
    // 
    Image1.Canvas.MoveTo(0, jj);
    Image1.Canvas.LineTo(Image1.Width, jj);
    Image1.Canvas.Pixels[Image1.Width, jj] := Image1.Canvas.Pen.Color
  end
end;

//
// obecʃOt쐬(ڐƃOt)
//
procedure TkmBattGraphForm.DrawAll();
//var
//  ImageRect: TRect;
begin
  // http://www.asahi-net.or.jp/~HA3T-NKMR/vcl2-12.htm
  // Ⴆ΁ATImage  Canvas gĐ}`݁A
  // ̌ TImage ̑傫ύXꍇAPicture.Graphic
  // Ɋi[Ă TBitmap ̑傫͕ω܂B
  // łATImage ̑傫傫ƁA
  // Canvas ŕ`ȂGAo܂B
  // Canvas  TImage ɕ`悤ɂɂ́APicture.Graphic
  // ɑĂ TBitmap jĐV傫
  // TBitmap 쐬KvL܂B
  // TImage ̃OtBbNjɂ
  // Image1.Picture := Nil;
  // Ƃ̂łȒPłB
  Image1.Picture := Nil; // TImagẽOtBbNj
  BattLogToGraphData();
  DrawBackColor();
  DrawScale();
  DrawBatteryGraph()
end;

////////////////////////////////////////////////////////////////
//
// t@C쐬֌W
//
////////////////////////////////////////////////////////////////

//
// LogText̓eFileNamẽt@C̍ŌɒǉB
// FileNamẽt@C݂Ȃꍇ͐VKɍ쐬B
// 1݂͍̏ő512܂(CR/LF܂)B𒴂̂
// ̂Ă
//
procedure WriteLogFile(FileName: String; LogText: String);
var
  FileStream1: TFileStream;
  FileWriteArray: Array [0..511] of Char;
  FileWriteLen: Integer;
  II: Integer;
  Header: String;
begin
  try
    // ݂΂̃t@Cg
    FileStream1 := TFileStream.Create(FileName, fmOpenReadWrite);
  except
    // ݂ȂΐV쐬擪Ƀwb_t
    FileStream1 := TFileStream.Create(FileName, fmCreate);
    Header := 'Date, Time, ACLineStatus, BatteryFlag, BatteryLifePercent, ' +
              'BatteryLifeTime' + #$D + #$A;
    FileWriteLen := Length(Header);
    for II := 0 to FileWriteLen - 1 do begin
      FileWriteArray[II] := Header[II + 1]
    end;
    FileStream1.WriteBuffer(FileWriteArray, FileWriteLen)
  end;
  // t@C̍ŌɃV[N
  FileStream1.Seek(0, soFromEnd);
  try
    FileWriteLen := Length(LogText);
    if FileWriteLen > SizeOf(FileWriteArray) then begin
      FileWriteLen := SizeOf(FileWriteArray)
    end;
    for II := 0 to FileWriteLen - 1 do begin
      FileWriteArray[II] := LogText[II + 1]
    end;
    FileStream1.WriteBuffer(FileWriteArray, FileWriteLen);
  finally
    FileStream1.Free
  end
end;

//
// 1s̃f[^csvt@Cɏ
//
procedure TkmBattGraphForm.AddBatteryLogToCsv();
var
  DateTimeStr: String;
  FolderPath: String;
begin
  FolderPath := ExtractFileDir(Application.ExeName);
  // CurrentDateTimeText͓̕tƎ̊Ԃ$20Ȃ̂ŎgȂ
  // ','̋؂̓tƎĂSYSTEMTIME͋ʂȂ̂
  // ͂Ȃ
  DateTimeStr :=
    Format('%4.4d-%2.2d-%2.2d,%2.2d:%2.2d:%2.2d',
    [CurrentSYSTEMTIME.wYear, CurrentSYSTEMTIME.wMonth,
     CurrentSYSTEMTIME.wDay, CurrentSYSTEMTIME.wHour,
     CurrentSYSTEMTIME.wMinute, CurrentSYSTEMTIME.wSecond]);
  csvOneLine :=  DateTimeStr + ',' +
                 ACLineStatusText + ',' + BatteryFlagText + ',' +
                 BatteryLifePercentText + ',' +
                 BatteryLifeTime1Text;
  WriteLogFile(FolderPath + '\' + BattGraphLogFile, csvOneLine + #$D + #$A);
  if makeEndlessLog then begin
    WriteLogFile(FolderPath + '\' + BattLogFile, csvOneLine + #$D + #$A)
  end
end;

////////////////////////////////////////////////////////////////
//
// CxgEnh
//
////////////////////////////////////////////////////////////////

//
// t[Ȃ\
//
procedure TkmBattGraphForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
      Style := Style or WS_THICKFRAME
end;

procedure TkmBattGraphForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //}EX{^ĂƂs
  If ssLeft in Shift then begin
    ReleaseCapture;
    SendMessage(kmBattGraphForm.Handle, WM_NCLBUTTONDOWN, HTCAPTION, 0)
  end
end;

//
// Image1̍̌vZ
//
procedure TkmBattGraphForm.CalcImage1Height();
var
  TempHeight: Integer;
begin
  if MenuShowXAxis.Checked then begin
    if StatusBar1.Visible then begin
      TempHeight := ClientHeight - BottomSpace - StatusBar1.Height
    end else begin
      TempHeight := ClientHeight - BottomSpace
    end
  end else begin 
    if StatusBar1.Visible then begin
      TempHeight := ClientHeight - StatusBar1.Height
    end else begin
      TempHeight := ClientHeight
    end
  end;
  // ɂȂȂ悤ɂ(ƃG[bZ[W\)
  if TempHeight < 0 then TempHeight := 0;
  Image1.Height := TempHeight
end;

//
// tH[ETCY
//
procedure TkmBattGraphForm.FormResize(Sender: TObject);
begin
  if Height < HeightMin then Height := HeightMin;
  if Width < WidthMin then Width := WidthMin;
  CalcImage1Height();
  DrawAll()
end;

//
// tH[EANeBx[g
//
procedure TkmBattGraphForm.FormActivate(Sender: TObject);
begin
//  WriteDebugString('FormActivate-Start' + #$D + #$A);
  if FirstRun then begin
    if StayTrayIcon then begin
      ShowTaskTray
    end;
    FirstRun := False
  end;
  DrawAll();
//  WriteDebugString('FormActivate-End' + #$D + #$A);
end;

//
// tH[
//
procedure TkmBattGraphForm.FormCreate(Sender: TObject);
var
  FullPath: String;
  TempLeft: Integer;
  TempTop: Integer;
  TempWidth: Integer;
  TempHeight: Integer;
  WindowPlacement: TWindowPlacement;
  TempWindowState: TWindowState;
  re: BOOL;
  ImageRect: TRect;
  ii: Integer;
  defaultStatusBarPanelIndexArray: Array[0..5] of Integer;
  tempStr: String;
begin
  for ii := 0 to 15 do begin
    tempStr := 'zIcon' + Format('%2.2d', [ii]);
    hTrayIcon[ii] := LoadIcon(HInstance,
                              PChar(tempStr));
  end;
  CurrentTrayIcon0to14 := -1;
  TrayIcon0to14 := -1;
  InFormCreate := True;
  FirstRun := True;
//  WriteDebugString('FormCreate-Start' + #$D + #$A);
  kmBattGraphForm.Caption := WindowName;
  // tƎ擾
  DecodeDateTime(Now, CurrentSYSTEMTIME.wYear, CurrentSYSTEMTIME.wMonth,
                 CurrentSYSTEMTIME.wDay, CurrentSYSTEMTIME.wHour,
                 CurrentSYSTEMTIME.wMinute, CurrentSYSTEMTIME.wSecond,
                 CurrentSYSTEMTIME.wMilliseconds);
  CurrentSYSTEMTIME.wMilliseconds := 0; // ms0҂ɂBʎq덷h~
  SystemTimeToFileTime(CurrentSYSTEMTIME, CurrentFILETIME);
  //
  FirstFlag := True;
  BatteryLifeTimeAvgIndex := 0;  // 
  BatteryLifeTimeAvgLength := 0; // 
  BatteryLifeTimeAvgSum := 0;    // 
  BatteryLifetimeAvgFull := False; // 
  // h~
  StatusBar1.DoubleBuffered := True;
  kmBattGraphForm.DoubleBuffered := True;
  // [U`bZ[W蓖Ă
  // RegisterWindowMessageœ̕o^Ɠ̃bZ[Wl
  // B*.dprł̕gpăbZ[Wl擾Ă
  WM_MyMessage := RegisterWindowMessage(TaskTrayMyMessage);
  // WM_USER + nŎ擾Sł͂ȂƎvB
  WM_NotifyTaskTray := RegisterWindowMessage(NotifyTaskTrayMessage);
  // Exploere.exeNƂ̃bZ[Ŵ
  // l𒲂ׂĂ
  uTaskBarRecreate := RegisterWindowMessage('TaskbarCreated');
  // X[EACR̎o
  ExtractIconEx(PChar(Application.ExeName), 0,
                hiconLarge, hiconSmall, 1);
  // Timer1̎Ԑݒ
  Timer1.Interval := 200; // 0.2b b5񔭐
  // init@C
  FullPath := ExtractFileDir(Application.ExeName) + '\kmBattGraph.ini';
  // Nɏ풓邩ǂ
  // 풓ɃtH[\邩ǂ
  MenuSetupStayInTaskTray.Checked := Boolean(GetPrivateProfileInt('Setup',
                        'StayInTaskTray',
                        defaultStayInTaskTray,
                        PChar(FullPath)));
  MenuSetupStayInTaskTrayAndHideAtRun.Checked :=
                             Boolean(GetPrivateProfileInt('Setup',
                             'StayInTaskTrayAndHideAtRun',
                             defaultStayInTaskTrayAndHideAtRun,
                             PChar(FullPath)));
  MenuSetupStayInTaskTrayAndOpenAtRun.Checked :=
                                Boolean(GetPrivateProfileInt('Setup',
                                'StayInTaskTrayAndOpenAtRun',
                                defaultStayInTaskTrayAndOpenAtRun,
                                PChar(FullPath)));
  // OpenHide͔rIȂ̂ŗTrueȂHideFalse
  if MenuSetupStayInTaskTrayAndHideAtRun.Checked and
    MenuSetupStayInTaskTrayAndOpenAtRun.Checked then begin
    MenuSetupStayInTaskTrayAndHideAtRun.Checked := False
  end;
  // j[Ɛݒ
  // ɎOɕ\邩ǂ
  MenuSetupStayOnTop.Checked := Boolean(GetPrivateProfileInt('Setup',
                                        'StayOnTop',
                                        defaultStayOnTop, PChar(FullPath)));
  if MenuSetupStayOnTop.Checked then begin
    //Form1.FormStyle := fsStayOnTop; //ł@\邪
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end;
  // eݒ
  MenuShowXAxis.Checked := Boolean(GetPrivateProfileInt('Setup',
                       'ShowXAxis', defaultShowXAxis,
                       PChar(FullPath)));
  CalcImage1Height();
  //
  MenuShowYAxis.Checked := Boolean(GetPrivateProfileInt('Setup',
                       'ShowYAxis', defaultShowYAxis,
                       PChar(FullPath)));
  if MenuShowYAxis.Checked then begin
    ShowYAxis()
  end else begin
    HideYAxis()
  end;
  ShowUnknownFactor1 := Boolean(GetPrivateProfileInt('Setup',
                       'ShowUnknownFactor1',
                       defaultShowUnknownFactor1,
                       PChar(FullPath)));
  ShowUnknownFactor2 := Boolean(GetPrivateProfileInt('Setup',
                       'ShowUnknownFactor2',
                       defaultShowUnknownFactor2,
                       PChar(FullPath)));
  CloseByDoubleClick := Boolean(GetPrivateProfileInt('Setup',
                        'CloseByDoubleClick',
                        defaultCloseByDoubleClick,
                        PChar(FullPath)));
  OpenByDoubleClickAtTaskTray := Boolean(GetPrivateProfileInt('Setup',
                                 'OpenByDoubleClickAtTaskTray',
                                 defaultOpenByDoubleClickAtTaskTray,
                                 PChar(FullPath)));
  CloseByDoubleClickAtTaskTray := Boolean(GetPrivateProfileInt('Setup',
                                 'CloseByDoubleClickAtTaskTray',
                                 defaultCloseByDoubleClickAtTaskTray,
                                 PChar(FullPath)));
  ShowExitMenuInTaskTray := Boolean(GetPrivateProfileInt('Setup',
                            'ShowExitMenuInTaskTray',
                            defaultShowExitMenuInTaskTray,
                            PChar(FullPath)));
  // init@C\ʒuǂނǂ̂܂܂ł͎gȂ
  TempLeft := GetPrivateProfileInt('Setup', 'Left', DefaultFormLeft,
                                   PChar(FullPath));
  TempTop := GetPrivateProfileInt('Setup', 'Top', DefaultFormTop,
                                  PChar(FullPath));
  TempWidth := GetPrivateProfileInt('Setup', 'Width', DefaultFormWidth,
                                    PChar(FullPath));
  TempHeight := GetPrivateProfileInt('Setup', 'Height', DefaultFormHeight,
                                     PChar(FullPath));
  //
  TempWindowState := TWindowState(GetPrivateProfileInt('Setup', 'WindowState',
                                  DefaultWindowState,
                                  PChar(FullPath)));
  // init@C̒l𒼐
  // Form1.LeftCForm1.TopCForm1.WidthCForm1.Height ɑĂ͂ȂB
  // R: fXNgbvOɔяođłȂȂ\B
  // h~邽߂ɂGetWindowPlacementŃEBhȄ
  // ǂݏoB
  WindowPlacement.length := SizeOf(WindowPlacement);
  re := GetWindowPlacement(Handle, @WindowPlacement);
  if (Integer(Re) = 0) then begin
    // G[Ȃ烁bZ[W\
    // 蓾Ȃ͂
    MessageDlg('FormCreate GetWindowPlacement ' +
               GetLastErrorStr(GetLastError()),
               mtInformation, [mbOK], 0);
    exit
  end;
  // m[}̑傫
  WindowPlacement.rcNormalPosition.Left := TempLeft;
  WindowPlacement.rcNormalPosition.Top := TempTop;
  WindowPlacement.rcNormalPosition.Right := TempLeft + TempWidth;
  WindowPlacement.rcNormalPosition.Bottom := TempTop + TempHeight;
  // h~
  // \ŋN̎CSW_HIDWݒ肵Ȃ
  // utH[\Ă܂
  if MenuSetupStayInTaskTrayAndHideAtRun.Checked then begin
    WindowPlacement.showCmd := SW_HIDE
  end;
  // ő剻ŕ\Ƃ̂܂Ȃ
  // ő剻ĂāCNɏ풓Ŕ\ݒ肵ďIꍇC
  // Nɔ\ɂȂB̂ƂtH[\ƒʏ̑傫ɂȂ
  // Windows^XN}l[W炱ł̂낤B
  // WindowsXpŃe[}WindowsNVbNɂƂ
  // Nɍő剻ŕ\Ēʏ̑傫ɖ߂
  // tH[̉EƉ̘gȂ邱ƂB207񂭂炢B
  // WindowsXp̃oÔ悤BWindows2000ł͔ȂB
  if (TempWindowState = wsMaximized) and
    not MenuSetupStayInTaskTrayAndHideAtRun.Checked
    then begin
    WindowPlacement.flags := WPF_RESTORETOMAXIMIZED;
    WindowPlacement.showCmd := SW_SHOWMAXIMIZED
  end;
  // SetWindowPlacementňʒuݒ肷B
  // R: SetWindowPlacement֐ŃEBhËʒuݒ肷
  // fXNgbv̊OɔяoƂɎIɕ␳B
  re := SetWindowPlacement(Handle, @WindowPlacement);
  if (Integer(Re) = 0) then begin
    // G[Ȃ烁bZ[W\
    // 蓾Ȃ͂
    MessageDlg('FormCreate SetWindowPlacement ' +
               GetLastErrorStr(GetLastError()),
               mtInformation, [mbOK], 0);
    exit
  end;
  // Nɏ풓ȂtOݒ肷
  MenuSetupStayInTaskTray.Checked :=
    MenuSetupStayInTaskTrayAndHideAtRun.Checked or
    MenuSetupStayInTaskTrayAndOpenAtRun.Checked;
  // Close/ExitύX
  ChangeFinishClose(MenuSetupStayInTaskTray.Checked);
  // \ŏ풓ȂtH[\Ȃ
  if MenuSetupStayInTaskTrayAndHideAtRun.Checked then begin
    Application.ShowMainForm := False;
    ShowTaskTray
  end;
  // \ŏ풓Ȃ^XNEgCɎ[̂
  if MenuSetupStayInTaskTray.Checked then begin
    ShowTaskTray
  end;
  //
  minutePerPixel := GetPrivateProfileInt('Setup', 'minutePerPixel',
                                         defaultMinutePerPixel,
                                         PChar(FullPath));
  rightEndIsCurrent := Boolean(GetPrivateProfileInt('Setup', 
                               'rightEndIsCurrent',
                               defaultRightEndIsCurrent,
                               PChar(FullPath)));
  rightEndTime := GetPrivateProfileInt('Setup', 'rightEndTime',
                                       defaultRightEndTime,
                                       PChar(FullPath));
  deleteTimer := GetPrivateProfileInt('Setup', 'deleteTimer',
                                      defaultDeleteTimer,
                                      PChar(FullPath));
  showStatusBar := Boolean(GetPrivateProfileInt('Setup',
                                'showStatusBar',
                                defaultshowStatusBar,
                                PChar(FullPath)));
  //
  colorBGoff := GetPrivateProfileInt('Setup', 'colorBGoff',
                                      defaultColorBGoff,
                                      PChar(FullPath));
  colorBGac := GetPrivateProfileInt('Setup', 'colorBGac',
                                      defaultColorBGac,
                                      PChar(FullPath));
  colorBGbatt := GetPrivateProfileInt('Setup', 'colorBGbatt',
                                      defaultColorBGbatt,
                                      PChar(FullPath));
  colorBGmix := GetPrivateProfileInt('Setup', 'colorBGmix',
                                      defaultColorBGmix,
                                      PChar(FullPath));
  colorScale1 := GetPrivateProfileInt('Setup', 'colorScale1',
                                      defaultColorScale1,
                                      PChar(FullPath));
  colorScale2 := GetPrivateProfileInt('Setup', 'colorScale2',
                                      defaultColorScale2,
                                      PChar(FullPath));
  colorGraph := GetPrivateProfileInt('Setup', 'colorGraph',
                                      defaultColorGraph,
                                      PChar(FullPath));
  //
  defaultStatusBarPanelIndexArray[0] := defaultStatusBarPanel0Index;
  defaultStatusBarPanelIndexArray[1] := defaultStatusBarPanel1Index;
  defaultStatusBarPanelIndexArray[2] := defaultStatusBarPanel2Index;
  defaultStatusBarPanelIndexArray[3] := defaultStatusBarPanel3Index;
  defaultStatusBarPanelIndexArray[4] := defaultStatusBarPanel4Index;
  defaultStatusBarPanelIndexArray[5] := defaultStatusBarPanel5Index;
  for ii := 0 to 5 do begin
    statusBarPanelIndex[ii] := GetPrivateProfileInt('Setup',
                             PChar('statusBarPanel' + IntToStr(ii) + 'Index'),
                               defaultStatusBarPanelIndexArray[ii],
                               PChar(FullPath));
  end;
  movingAvgMax := GetPrivateProfileInt('Setup', 'movingAvgMax',
                                      defaultmovingAvgMax,
                                      PChar(FullPath));
  movingAvgMaxNew := movingAvgMax;
  makeEndlessLog := Boolean(GetPrivateProfileInt('Setup',
                                'makeEndlessLog',
                                defaultMakeEndlessLog,
                                PChar(FullPath)));
  //
  StatusBar1.Visible := showStatusBar;
  MenuShowStatusBar.Checked := showStatusBar;
  CalcImage1Height();
  // h悭邽߂ɃobeEXeC^X擾ĕ\
  GetSystemPS;
  // csvt@C̓ǂݍ݂I܂ŃOC̕\
  Image1.Canvas.Brush.Color := colorBGoff;
  ImageRect.Left := 0;
  ImageRect.Top := 0;
  ImageRect.Right := Image1.Width;
  ImageRect.Bottom := Image1.Height;
  Image1.Canvas.FillRect(ImageRect);
  DrawScale();
  // csvt@CǂݍTBattLog^̔z
  // csvt@ČÂR[h폜
  CsvToBattLogArrayAndTrim();
  // \
  DrawAll();
  Timer1Timer(Self);
  BuildStatusBarPanel();
  DrawStatusPanel();
  // tH[쐬ĂȂƂɑIԂƃG[ɂȂ̂h~
  MenuFile.Enabled := True;
  MenuSetup.Enabled := True;
  MenuAbout.Enabled := True;
  MenuFile.Enabled := True;
  //
  MenuOpen.Enabled := True;
  // ^C}N
  Timer1.Enabled := True;
//  WriteDebugString('FormCreate-End' + #$D + #$A);
  InFormCreate := False;
end;

//
// tH[ING
//
procedure TkmBattGraphForm.FormCloseQuery(Sender: TObject;
                                          var CanClose: Boolean);
var
  FullPath: String;
  re: BOOL;
  WindowPlacement: TWindowPlacement;
  WindowTop: Integer;
  WindowLeft: Integer;
  WindowWidth: Integer;
  WindowHeight: Integer;
  ii: Integer;
begin
  if (StayTrayIcon) and (WMQueryEndSessionFlag = False) Then begin
    ShowTaskTray;
    // Form1.Hide;
    // ShowWindow(Form1.Handle, SW_HIDE);
    // Application.ShowMainForm := False;
    // ͂3̈Ⴂ悭킩ĂȂ肷()B
    kmBattGraphForm.Hide; // []ŃtH[ƂɗL
    // szTipւ
    if StayTrayIcon then begin
      ShowTaskTray
    end;
    CanClose := False
  end else begin
    // x폜
    FreeAndNil(AYLabelList);
    FreeAndNil(AXLabelList);
    // ̃EBhËʒu擾
    // Form1.TopCLeftCWidthCHeightgpĂ͂Ȃ
    // R: ő剻ĂƂɍő剻ĂW擾Ă܂B
    // ő剻ĂƂłʏ̍W擾KvB
    WindowPlacement.length := SizeOf(WindowPlacement);
    re := GetWindowPlacement(Handle, @WindowPlacement);
    if (Integer(Re) = 0) then begin
      // G[Ȃ烁bZ[W\
      // 蓾Ȃ͂
      MessageDlg('FormCloseQuery ' + GetLastErrorStr(GetLastError()),
                 mtInformation, [mbOK], 0);
      CanClose := False;
      exit
    end;
    // ƍvZ
    WindowTop := WindowPlacement.rcNormalPosition.Top;
    WindowLeft := WindowPlacement.rcNormalPosition.Left;
    WindowWidth := WindowPlacement.rcNormalPosition.Right -
                   WindowPlacement.rcNormalPosition.Left;
    WindowHeight := WindowPlacement.rcNormalPosition.Bottom -
                    WindowPlacement.rcNormalPosition.Top;
    //
    FullPath := ExtractFileDir(Application.ExeName) + '\kmBattGraph.ini';
    //
    WritePrivateProfileString('Setup', 'Left',
                              PChar(IntToStr(WindowLeft)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'Top',
                              PChar(IntToStr(WindowTop)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'Width',
                              PChar(IntToStr(WindowWidth)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'Height',
                              PChar(IntToStr(WindowHeight)),
                              PChar(FullPath));
    //
    WritePrivateProfileString('Setup', 'minutePerPixel',
                              PChar(IntToStr(minutePerPixel)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'rightEndIsCurrent',
                              PChar(IntToStr(Integer(rightEndIsCurrent))),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'rightEndTime',
                              PChar(IntToStr(rightEndTime)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'deleteTimer',
                              PChar(IntToStr(deleteTimer)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'StayInTaskTray',
                  PChar(IntToStr(Integer(MenuSetupStayInTaskTray.Checked))),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'StayInTaskTrayAndHideAtRun',
        PChar(IntToStr(Integer(MenuSetupStayInTaskTrayAndHideAtRun.Checked))),
        PChar(FullPath));
    WritePrivateProfileString('Setup', 'StayInTaskTrayAndOpenAtRun',
        PChar(IntToStr(Integer(MenuSetupStayInTaskTrayAndOpenAtRun.Checked))),
        PChar(FullPath));
    WritePrivateProfileString('Setup', 'showStatusBar',
                          PChar(IntToStr(Integer(showStatusBar))),
                          PChar(FullPath));
    //
    WritePrivateProfileString('Setup', 'ShowXAxis',
                              PChar(IntToStr(Integer(MenuShowXAxis.Checked))),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'ShowYAxis',
                              PChar(IntToStr(Integer(MenuShowYAxis.Checked))),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'ShowUnknownFactor1',
                              PChar(IntToStr(Integer(ShowUnknownFactor1))),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'ShowUnknownFactor2',
                              PChar(IntToStr(Integer(ShowUnknownFactor2))),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'CloseByDoubleClick',
                              PChar(IntToStr(Integer(CloseByDoubleClick))),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'OpenByDoubleClickAtTaskTray',
                        PChar(IntToStr(Integer(OpenByDoubleClickAtTaskTray))),
                        PChar(FullPath));
    WritePrivateProfileString('Setup', 'CloseByDoubleClickAtTaskTray',
                        PChar(IntToStr(Integer(CloseByDoubleClickAtTaskTray))),
                        PChar(FullPath));
    WritePrivateProfileString('Setup', 'ShowExitMenuInTaskTray',
                        PChar(IntToStr(Integer(ShowExitMenuInTaskTray))),
                        PChar(FullPath));
    //
    WritePrivateProfileString('Setup', 'colorBGoff',
                              PChar(IntToStr(colorBGoff)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'colorBGac',
                              PChar(IntToStr(colorBGac)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'colorBGbatt',
                              PChar(IntToStr(colorBGbatt)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'colorBGmix',
                              PChar(IntToStr(colorBGmix)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'colorScale1',
                              PChar(IntToStr(colorScale1)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'colorScale2',
                              PChar(IntToStr(colorScale2)),
                              PChar(FullPath));
    WritePrivateProfileString('Setup', 'colorGraph',
                              PChar(IntToStr(colorGraph)),
                              PChar(FullPath));
    //
    for ii := 0 to 5 do begin
      WritePrivateProfileString('Setup', PChar('statusBarPanel' +
                                IntToStr(ii) +  
                                'Index'),
                                PChar(IntToStr(statusBarPanelIndex[ii])),
                                PChar(FullPath));
    end;
    //
    WritePrivateProfileString('Setup', 'movingAvgMax',
                              PChar(IntToStr(movingAvgMaxNew)),
                              PChar(FullPath));
    //
    WritePrivateProfileString('Setup', 'makeEndlessLog',
                              PChar(IntToStr(Integer(makeEndlessLog))),
                              PChar(FullPath));
    //
    CanClose := True
  end
end;

//
// I
//
procedure TkmBattGraphForm.MenuFileExitClick(Sender: TObject);
begin
  Close
end;

//
// AoEgEo[WEj[̏
//
procedure TkmBattGraphForm.MenuAboutVersionClick(Sender: TObject);
begin
  AboutForm.ShowModal
end;

//
// ݒ胁j[̏
//
procedure TkmBattGraphForm.MenuSetupTimeClick(Sender: TObject);
var
  FILETIME: TFILETIME;
  SYSTEMTIME: TSYSTEMTIME;
  u64: TUnion64;
begin
  // ɎOɕ\ʒuIɉ
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  DisableTopMost := True;
  // minutePerPixelComboBoxItemIndexɕϊ
  case minutePerPixel of
    1:     Setup1Form.ComboBox1.ItemIndex := 0;
    2:     Setup1Form.ComboBox1.ItemIndex := 1;
    5:     Setup1Form.ComboBox1.ItemIndex := 2;
    10:    Setup1Form.ComboBox1.ItemIndex := 3;
    20:    Setup1Form.ComboBox1.ItemIndex := 4;
    30:    Setup1Form.ComboBox1.ItemIndex := 5;
    60:    Setup1Form.ComboBox1.ItemIndex := 6;
    120:   Setup1Form.ComboBox1.ItemIndex := 7;
    300:   Setup1Form.ComboBox1.ItemIndex := 8;
    600:   Setup1Form.ComboBox1.ItemIndex := 9;
    1440:  Setup1Form.ComboBox1.ItemIndex := 10;
    2880:  Setup1Form.ComboBox1.ItemIndex := 11;
    7200:  Setup1Form.ComboBox1.ItemIndex := 12;
    10080: Setup1Form.ComboBox1.ItemIndex := 13;
    20160: Setup1Form.ComboBox1.ItemIndex := 14;
    43200: Setup1Form.ComboBox1.ItemIndex := 15;
    else   Setup1Form.ComboBox1.ItemIndex := 0
  end;
  // deleteTimerComboBoxItemIndexɕϊ
  case deleteTimer of
    10080:  Setup1Form.ComboBox2.ItemIndex := 0;
    20160:  Setup1Form.ComboBox2.ItemIndex := 1;
    30240:  Setup1Form.ComboBox2.ItemIndex := 2;
    43200:  Setup1Form.ComboBox2.ItemIndex := 3;
    86400:  Setup1Form.ComboBox2.ItemIndex := 4;
    129600: Setup1Form.ComboBox2.ItemIndex := 5;
    259200: Setup1Form.ComboBox2.ItemIndex := 6;
    525600: Setup1Form.ComboBox2.ItemIndex := 7;
    else    Setup1Form.ComboBox2.ItemIndex := 7
  end;
  // \ݒ肷
  u64.w64 := rightEndTime * K;
  FILETIME.dwHighDateTime := u64.h32;
  FILETIME.dwLowDateTime := u64.l32;
  FileTimeToSystemTime(FILETIME, SYSTEMTIME);
  Setup1Form.SpinEdit1.Value := SYSTEMTIME.wYear;
  Setup1Form.SpinEdit2.Value := SYSTEMTIME.wMonth;
  Setup1Form.SpinEdit3.Value := SYSTEMTIME.wDay;
  Setup1Form.SpinEdit4.Value := SYSTEMTIME.wHour;
  Setup1Form.SpinEdit5.Value := SYSTEMTIME.wMinute;
  //
  Setup1Form.rightEndFILETIME := FILETIME;
  Setup1Form.rightEndSYSTEMTIME := SYSTEMTIME;
  //
  if rightEndIsCurrent then begin
    Setup1Form.RadioButton1.Checked := True;
    Setup1Form.RadioButton2.Checked := False
  end else begin
    Setup1Form.RadioButton1.Checked := False;
    Setup1Form.RadioButton2.Checked := True
  end;
  Setup1Form.CheckBox1.Checked := makeEndlessLog;
  // LZꂽƂɌɖ߂
  Setup1Form.prevRightEndTime := rightEndTime;
  Setup1Form.prevRightEndIsCurrent := RightEndIsCurrent;
  Setup1Form.prevMinutePerPixel := minutePerPixel;
  // \
  Setup1Form.ShowModal;
  // ĕ`
  DrawAll();
  // ɎOɕ\Đݒ
  DisableTopMost := False;
  if MenuSetupStayOnTop.Checked then begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end
end;

//
// F̐ݒʂ\
//
procedure TkmBattGraphForm.MenuSetupColorClick(Sender: TObject);
var
  ImageRect: TRect;
begin
  // ɎOɕ\ʒuIɉ
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  DisableTopMost := True;
  //
  Setup2Form.Image1.Canvas.Brush.Color := colorBGoff;
  ImageRect.Left := 0;
  ImageRect.Top := 0;
  ImageRect.Right := Setup2Form.Image1.Width;
  ImageRect.Bottom := Setup2Form.Image1.Height;
  Setup2Form.Image1.Canvas.FillRect(ImageRect);
  //
  Setup2Form.Image2.Canvas.Brush.Color := colorBGac;
  ImageRect.Left := 0;
  ImageRect.Top := 0;
  ImageRect.Right := Setup2Form.Image2.Width;
  ImageRect.Bottom := Setup2Form.Image2.Height;
  Setup2Form.Image2.Canvas.FillRect(ImageRect);
  //
  Setup2Form.Image3.Canvas.Brush.Color := colorBGbatt;
  ImageRect.Left := 0;
  ImageRect.Top := 0;
  ImageRect.Right := Setup2Form.Image3.Width;
  ImageRect.Bottom := Setup2Form.Image3.Height;
  Setup2Form.Image3.Canvas.FillRect(ImageRect);
  //
  Setup2Form.Image4.Canvas.Brush.Color := colorBGmix;
  ImageRect.Left := 0;
  ImageRect.Top := 0;
  ImageRect.Right := Setup2Form.Image4.Width;
  ImageRect.Bottom := Setup2Form.Image4.Height;
  Setup2Form.Image4.Canvas.FillRect(ImageRect);
  //
  Setup2Form.Image5.Canvas.Brush.Color := colorScale1;
  ImageRect.Left := 0;
  ImageRect.Top := 0;
  ImageRect.Right := Setup2Form.Image5.Width;
  ImageRect.Bottom := Setup2Form.Image5.Height;
  Setup2Form.Image5.Canvas.FillRect(ImageRect);
  //
  Setup2Form.Image7.Canvas.Brush.Color := colorScale2;
  ImageRect.Left := 0;
  ImageRect.Top := 0;
  ImageRect.Right := Setup2Form.Image7.Width;
  ImageRect.Bottom := Setup2Form.Image7.Height;
  Setup2Form.Image7.Canvas.FillRect(ImageRect);
  //
  Setup2Form.Image6.Canvas.Brush.Color := colorGraph;
  ImageRect.Left := 0;
  ImageRect.Top := 0;
  ImageRect.Right := Setup2Form.Image6.Width;
  ImageRect.Bottom := Setup2Form.Image6.Height;
  Setup2Form.Image6.Canvas.FillRect(ImageRect);
  //
  Setup2Form.ShowModal;
  // ĕ`
  DrawAll();
  // ɎOɕ\Đݒ
  DisableTopMost := False;
  if MenuSetupStayOnTop.Checked then begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end
end;
//
// ^XNEgC̊JJ
//
procedure TkmBattGraphForm.MenuOpenClick(Sender: TObject);
begin
  kmBattGraphForm.Show;
  Application.Restore
end;

//
// ^XNEgCɃACR\邩ǂ
// (풓邩ǂ)
//
procedure TkmBattGraphForm.MenuSetupStayInTaskTrayClick(Sender: TObject);
begin
  MenuSetupStayInTaskTray.Checked := Not MenuSetupStayInTaskTray.Checked;
  ChangeFinishClose(MenuSetupStayInTaskTray.Checked)
end;

//
// Nɔ\ŏ풓邩ǂinit@Cɏ
//
procedure TkmBattGraphForm.MenuSetupStayInTaskTrayAndHideAtRunClick(
  Sender: TObject);
var
  FullPath: String;
begin
  FullPath := ExtractFileDir(Application.ExeName) + '\kmBattGraph.ini';
  MenuSetupStayInTaskTrayAndHideAtRun.Checked :=
    Not MenuSetupStayInTaskTrayAndHideAtRun.Checked;
  MenuSetupStayInTaskTrayAndOpenAtRun.Checked := False;
  WritePrivateProfileString('Setup', 'StayInTaskTrayAndHideAtRun',
         PChar(IntToStr(Integer(MenuSetupStayInTaskTrayAndHideAtRun.Checked))),
         PChar(FullPath));
  WritePrivateProfileString('Setup', 'StayInTaskTrayAndOpenAtRun',
         PChar(IntToStr(Integer(MenuSetupStayInTaskTrayAndOpenAtRun.Checked))),
         PChar(FullPath))
end;

//
// NɃtH[\ŏ풓邩ǂinit@Cɏ
//
procedure TkmBattGraphForm.MenuSetupStayInTaskTrayAndOpenAtRunClick(Sender:
                                                                TObject);
var
  FullPath: String;
begin
  FullPath := ExtractFileDir(Application.ExeName) + '\kmBattGraph.ini';
  MenuSetupStayInTaskTrayAndHideAtRun.Checked := False;
  MenuSetupStayInTaskTrayAndOpenAtRun.Checked :=
    Not MenuSetupStayInTaskTrayAndOpenAtRun.Checked;
  WritePrivateProfileString('Setup', 'StayInTaskTrayAndHideAtRun',
         PChar(IntToStr(Integer(MenuSetupStayInTaskTrayAndHideAtRun.Checked))),
         PChar(FullPath));
  WritePrivateProfileString('Setup', 'StayInTaskTrayAndOpenAtRun',
         PChar(IntToStr(Integer(MenuSetupStayInTaskTrayAndOpenAtRun.Checked))),
         PChar(FullPath))
end;

//
// Xe[^XEo[\
//
procedure TkmBattGraphForm.MenuShowStatusBarClick(Sender: TObject);
begin
  StatusBar1.Visible := not StatusBar1.Visible;
  showStatusBar := StatusBar1.Visible;
  MenuShowStatusBar.Checked := StatusBar1.Visible;
  CalcImage1Height();
  DrawAll()
end;

//
// ^XNEo[̐ݒ胁j[\
//
procedure TkmBattGraphForm.MenuSetupStatusBarClick(Sender: TObject);
begin
  // ɎOɕ\ʒuIɉ
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  DisableTopMost := True;
  //
  Setup3Form.ComboBox1.ItemIndex := statusBarPanelIndex[0];
  Setup3Form.ComboBox2.ItemIndex := statusBarPanelIndex[1];
  Setup3Form.ComboBox3.ItemIndex := statusBarPanelIndex[2];
  Setup3Form.ComboBox4.ItemIndex := statusBarPanelIndex[3];
  Setup3Form.ComboBox5.ItemIndex := statusBarPanelIndex[4];
  Setup3Form.ComboBox6.ItemIndex := statusBarPanelIndex[5];
  Setup3Form.StatusBarPanelGrayOut;
  Setup3Form.Edit1.Text := IntToStr(movingAvgMax);
  Setup3Form.SpinEdit1.Value := movingAvgMaxNew;
  Setup3Form.ShowModal;
  BuildStatusBarPanel();
  DrawStatusPanel();
  // ɎOɕ\Đݒ
  DisableTopMost := False;
  if MenuSetupStayOnTop.Checked then begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end
end;

//
// tH[̃_uENbNŕ
//
procedure TkmBattGraphForm.Image1DblClick(Sender: TObject);
begin
  if StayTrayIcon and CloseByDoubleClick then begin
    kmBattGraphForm.Hide;
    ShowTaskTray
  end
end;

//
// j[Ɠݒ\
//
procedure TkmBattGraphForm.MenuSetupMenuOperationClick(Sender: TObject);
begin
  // ɎOɕ\ʒuIɉ
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  DisableTopMost := True;
  //
  Setup4Form.CheckBox1.Checked := ShowExitMenuInTaskTray;
  Setup4Form.CheckBox2.Checked := OpenByDoubleClickAtTaskTray;
  Setup4Form.CheckBox3.Checked := CloseByDoubleClick;
  Setup4Form.CheckBox4.Checked := ShowUnknownFactor1;
  Setup4Form.CheckBox5.Checked := ShowUnknownFactor2;
  Setup4Form.CheckBox6.Checked := CloseByDoubleClickAtTaskTray;
  Setup4Form.EnableDisable;
  Setup4Form.ShowModal;
  // szTipւ
  if StayTrayIcon then begin
    ShowTaskTray
  end;
  // 풓ĂƂɏIj[ǉ/폜
  MenuExitTrim;
  // ɎOɕ\Đݒ
  DisableTopMost := False;
  if MenuSetupStayOnTop.Checked then begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end
end;

//
// 풓ĂƂɏIj[ǉ/폜
//
procedure TkmBattGraphForm.MenuExitTrim;
var
  MenuItem1: TMenuItem;
begin
  if StayTrayIcon and ShowExitMenuInTaskTray then begin
    if MenuFile.Count = 1 then begin
      // j[̓Iǉ
      MenuItem1 :=TMenuItem.Create(Self);
      MenuItem1.Caption   := 'I(&X)';
      MenuItem1.Name      := 'MenuFileAddedExit';
      MenuItem1.Tag       := 0;
      //Cxg̓I蓖
      MenuItem1.OnClick   := kmBattGraphForm.MenuFileAddedExitClick;
                                      // (Self)ȂƂɒ
                                      // R:|C^
      MenuFile.Add(MenuItem1);
    end
  end else begin
    if MenuFile.Count = 2 then begin
      // j[̓I폜
      MenuFile[1].Name := '';  // DeleteĂNameMenuItemȂ̂
      MenuFile.Delete(1);      // NameςĂDelete
                               // 悭킩Ȃ̂őΏƗÖ@肷
    end
  end
end;

//
// 풓ԂďI
//
procedure TkmBattGraphForm.MenuFileAddedExitClick(Sender: TObject);
begin
  HideTaskTray;
  Close
end;

//
// ɎOɕ\
//
procedure TkmBattGraphForm.MenuSetupStayOnTopClick(Sender: TObject);
var
  FullPath: String;
begin
  if (MenuSetupStayOnTop.Checked = False) then begin
    MenuSetupStayOnTop.Checked := True;
    //Form1.FormStyle := fsStayOnTop; //ł@\邪
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end else begin
    MenuSetupStayOnTop.Checked := False;
    //Form1.FormStyle := fsNorma;     //ł@\邪
    SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end;
  FullPath := ExtractFileDir(Application.ExeName) + '\kmBattGraph.ini';
  WritePrivateProfileString('Setup', 'StayOnTop',
                        PChar(IntToStr(Integer(MenuSetupStayOnTop.Checked))),
                        PChar(FullPath))
end;

//
// ɎOɕ\(⏕)
// ܂ɌɂȂĂ܂Ƃ邻Ȃ̂ŁCPaint̂ƂɑOɎĂ
//
procedure TkmBattGraphForm.FormPaint(Sender: TObject);
begin
  if MenuSetupStayOnTop.Checked and (not DisableTopMost) then begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE)
  end
end;

//
// Y(obec)̐l\
//
procedure TkmBattGraphForm.ShowYAxis();
begin
  Image1.Left := 18;
  Image1.Width := kmBattGraphForm.ClientWidth - Image1.Left;
end;

//
// Y(obec)̐l\ɂ
//
procedure TkmBattGraphForm.HideYAxis();
begin
  Image1.Left := 0;
  Image1.Width := kmBattGraphForm.ClientWidth - Image1.Left;
end;

//
// Y(obecʎ)̐l̕\/\̐؊
//
procedure TkmBattGraphForm.MenuShowYAxisClick(Sender: TObject);
begin
  if MenuShowYAxis.Checked then begin
    MenuShowYAxis.Checked := False;
    HideYAxis()
  end else begin
    MenuShowYAxis.Checked := True;
    showYAxis()
  end;
  DrawAll()
end;

//
// X(Ԏ)̐l̕\/\̐؊
//
procedure TkmBattGraphForm.MenuShowXAxisClick(Sender: TObject);
begin
  MenuShowXAxis.Checked := not MenuShowXAxis.Checked;
  CalcImage1Height();
  DrawAll()
end;

////////////////////////////////////////////////////////////////
//
// ^C}֌W̃Cxg
//
////////////////////////////////////////////////////////////////

//
// ^C}ʏ
// obȅԂ擾
//
procedure TkmBattGraphForm.GetSystemPS();
var
  SystemPowerStatus1: TSystemPowerStatus;
  ValidValueFlag: Boolean;
  LeftSeconds: DWORD;
  LeftSecondsAvg: DWORD;
  u64: TUnion64;
  FILETIME: TFILETIME;
  SYSTEMTIME: TSYSTEMTIME;
begin
  if GetSystemPowerStatus(SystemPowerStatus1) then begin
    // ACLineStatus
    case SystemPowerStatus1.ACLineStatus of
    0:
      ACLineStatusText := 'Battery';
    1:
      ACLineStatusText := 'AC';
    255:
      ACLineStatusText := 'Unknown';
    else
      ACLineStatusText := 'Undefine: ' +
                          IntToStr(SystemPowerStatus1.ACLineStatus)
    end;
    // BatteryFlag
    ValidValueFlag := False;
    if SystemPowerStatus1.BatteryFlag = 255 then begin
      BatteryFlagText := 'Unknown';
      ValidValueFlag := True
    end else begin
      BatteryFlagText := '';
      if Boolean(SystemPowerStatus1.BatteryFlag and $1) then begin
        BatteryFlagText := 'High';
        ValidValueFlag := True
      end;
      if Boolean(SystemPowerStatus1.BatteryFlag and $2) then begin
        ValidValueFlag := True;
        if BatteryFlagText <> '' then begin
          BatteryFlagText := BatteryFlagText + '-'
        end;
        BatteryFlagText := BatteryFlagText + 'Low'
      end;
      if Boolean(SystemPowerStatus1.BatteryFlag and $4) then begin
        ValidValueFlag := True;
        if BatteryFlagText <> '' then begin
          BatteryFlagText := BatteryFlagText + '-'
        end;
        BatteryFlagText := BatteryFlagText + 'Critical'
      end;
      if Boolean(SystemPowerStatus1.BatteryFlag and $8) then begin
        ValidValueFlag := True;
        if BatteryFlagText <> '' then begin
          BatteryFlagText := BatteryFlagText + '-'
        end;
        BatteryFlagText := BatteryFlagText + 'Charging'
      end;
      if Boolean(SystemPowerStatus1.BatteryFlag and $80) then begin
        ValidValueFlag := True;
        if BatteryFlagText <> '' then begin
          BatteryFlagText := BatteryFlagText + '-'
        end;
        BatteryFlagText := BatteryFlagText + 'No system battery'
      end
    end;
    if ValidValueFlag = False then begin
      if SystemPowerStatus1.BatteryFlag = 0 then begin
        BatteryFlagText := 'Normal'
      end else begin
        BatteryFlagText := 'Undefine: ' +
                           IntToStr(SystemPowerStatus1.BatteryFlag)
      end;
    end;
    // BatteryLifePercent 0-100, 255
    case SystemPowerStatus1.BatteryLifePercent of
      255: begin
        BatteryLifePercentText := 'Unknown';
        TrayIcon0To14 := -1;
      end;
      else begin
        BatteryLifePercentText := 
          IntToStr(SystemPowerStatus1.BatteryLifePercent);
          TrayIcon0To14:= SystemPowerStatus1.BatteryLifePercent * 14 div 100;
      end
    end;
    //
    LeftSeconds := SystemPowerStatus1.BatteryLifeTime;
    //
    // fobOpɒl㏑
//    if DebugForm <> nil then begin
//      LeftSeconds := DebugForm.SpinEdit1.Value;
//      if DebugForm.CheckBox1.Checked then begin
//        LeftSeconds := $FFFFFFFF
//      end;
//    end;
    // fobO㏑܂
    //
    // obe쓮̎c莞Ԃ̕bHHMMSSɊZ
    BatteryLifeTime1Text := SecondsToHHMMSS(LeftSeconds);
    // obe0ɂȂ鎞vZ
    // ݎɎcbZ
    if DWORD(LeftSeconds) = $FFFFFFFF then begin
      // UnknownȂړόvZp^
      BatteryLifeTime2Text := 'Unknown';
      BatteryLifeTimeAvgLength := 0;
      BatteryLifeTimeAvgFull := False;  // 
      BatteryLifeTimeAvgIndex := 0;     //
      BatteryLifeTimeAvgSum := 0        //
    end else begin
      // ړςvZ
      if BatteryLifeTimeAvgLength < MovingAvgMax then begin
        BatteryLifeTimeAvgLength := BatteryLifeTimeAvgLength + 1;
        // ϒzm
        SetLength(BatteryLifeTimeAvgArray, BatteryLifeTimeAvgLength);
      end else begin
        BatteryLifeTimeAvgFull := True
      end;
      if BatteryLifeTimeAvgFull then begin
        BatteryLifeTimeAvgSum := BatteryLifeTimeAvgSum + LeftSeconds -
                        BatteryLifeTimeAvgArray[BatteryLifeTimeAvgIndex];
      end else begin
        BatteryLifeTimeAvgSum := BatteryLifeTimeAvgSum + LeftSeconds;
      end;
      BatteryLifeTimeAvgArray[BatteryLifeTimeAvgIndex] := LeftSeconds;
      // bvEAEhvZ
      BatteryLifeTimeAvgIndex :=
        (BatteryLifeTimeAvgIndex + 1) mod MovingAvgMax;
      // ςvZ
      LeftSecondsAvg := BatteryLifeTimeAvgSum div BatteryLifeTimeAvgLength;
      // ݎ
      u64.h32 := CurrentFILETIME.dwHighDateTime;
      u64.l32 := CurrentFILETIME.dwLowDateTime;
      u64.w64 := u64.w64 + LeftSecondsAvg * K div 60;
      FILETIME.dwHighDateTime := u64.h32;
      FILETIME.dwLowDateTime := u64.l32;
      FileTimeToSystemTime(FILETIME, SYSTEMTIME);
      BatteryLifeTime2Text :=
        Format('%2.2d-%2.2d %2.2d:%2.2d:%2.2d',
        [SYSTEMTIME.wMonth, SYSTEMTIME.wDay,
         SYSTEMTIME.wHour, SYSTEMTIME.wMinute, SYSTEMTIME.wSecond])
    end;
    //
    // fobOp
//    if DebugForm <> nil then begin
//      DebugForm.Edit1.Text := ('AvgLength: ' +
//                                IntToStr(BatteryLifeTimeAvgLength));
//      DebugForm.Edit2.Text := ('AvgIndex: ' +
//                                IntToStr(BatteryLifeTimeAvgIndex));
//      DebugForm.Edit3.Text := ('AvgFull: ' +
//                                BoolToStr(BatteryLifeTimeAvgFull, True));
//      DebugForm.Edit4.Text := ('ArrayLength: ' +
//                                IntToStr(Length(BatteryLifeTimeAvgArray)))
//    end
    // fobOp܂
    //
  end else begin
    // ʏ킠蓾Ȃ
    ShowMessage('GetSystemPowerStatus: ' + GetLastErrorStr(GetLastError()))
  end
end;

//
//  ^C}荞݂̏
//  200msƂɊ荞ށB
//  b𔻒肵ĕbω1b1̏ĂԁB
//  𔻒肵ĕω11̏ĂԁB
//  1b荞݁C1荞݂菈͖ʓ|I[owbh傫
//  ҂590bɈڂƂɏŝŏꂢB
//  dgvƂ킹ƃfobO₷ꂪȗR
//
procedure TkmBattGraphForm.Timer1Timer(Sender: TObject);
var
  ll: Integer;
begin
  // tƎ擾
  DecodeDateTime(Now, CurrentSYSTEMTIME.wYear, CurrentSYSTEMTIME.wMonth,
                 CurrentSYSTEMTIME.wDay, CurrentSYSTEMTIME.wHour,
                 CurrentSYSTEMTIME.wMinute, CurrentSYSTEMTIME.wSecond,
                 CurrentSYSTEMTIME.wMilliseconds);
  CurrentSYSTEMTIME.wMilliseconds := 0; // ms0҂ɂBʎq덷h~
  CurrentDateTimeText :=
    Format('%4.4d-%2.2d-%2.2d %2.2d:%2.2d:%2.2d',
    [CurrentSYSTEMTIME.wYear, CurrentSYSTEMTIME.wMonth,
     CurrentSYSTEMTIME.wDay, CurrentSYSTEMTIME.wHour,
     CurrentSYSTEMTIME.wMinute, CurrentSYSTEMTIME.wSecond]);
  SystemTimeToFileTime(CurrentSYSTEMTIME, CurrentFILETIME);
  // obeԂ擾
  if FirstFlag then begin
    // ŏ1񂾂̏
    FirstFlag := False;
    PrevMinute := CurrentSYSTEMTIME.wMinute;
    PrevSecond := CurrentSYSTEMTIME.wSecond
  end;
  // 1b1̏
  if PrevSecond <> CurrentSYSTEMTIME.wSecond then begin
    GetSystemPS();
    DrawStatusPanel();
    // Ă珑
    if (CurrentTrayIcon0to14 <> TrayIcon0to14) and StayTrayIcon then begin
      ShowTaskTray
    end
  end;
  // 11̏
  if PrevMinute <> CurrentSYSTEMTIME.wMinute then begin
    // csvt@Cɏ
    // csvt@C͎̋NɎQƂB܂͏ނ
    // QƂȂ
    AddBatteryLogToCsv();
    // zЂƂ傫
    ll := Length(BattLogArray);
    // TBattLog^̔zЂƂ傫
    SetLength(BattLogArray, ll + 1);
    // ̑₵ɍ̃OL^
    CsvToBattLogType(csvOneLine, BattLogArray[ll]);
    // ĕ`
    DrawAll()
  end;
  PrevMinute := CurrentSYSTEMTIME.wMinute;
  PrevSecond := CurrentSYSTEMTIME.wSecond
end;

end.
